using System;
using System.Runtime.InteropServices;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for CUtil.
	/// </summary>
	public class CUtil
	{		
		[DllImport("User32.dll")]
		private static extern bool SendMessage(IntPtr hwnd, UInt32 msg, UInt32 
			wParam, UInt32 lParam);

		public static void ScrollDown(IntPtr WindowHandle)
		{
			const System.Int32 WM_VSCROLL = 0x115;
			const System.Int32 SB_LINEDOWN = 0x1;

			SendMessage(WindowHandle, WM_VSCROLL, SB_LINEDOWN , 0);
		}

		public static void ScrollUp(IntPtr WindowHandle)
		{
			const System.Int32 WM_VSCROLL = 0x115;
			const System.Int32 SB_LINEUP = 0;

			SendMessage(WindowHandle, WM_VSCROLL, SB_LINEUP , 0);
		}

		static public object nz(object obj,object replacewith)
		{
			if (obj.GetType() != typeof(DBNull))
			{
				return obj;
			}
			else
			{
				return replacewith;
			}
		}
		
		static public System.Data.OleDb.OleDbParameter NewParam(string name, System.Data.OleDb.OleDbType dataType, object Value)
		{
			System.Data.OleDb.OleDbParameter temp = new System.Data.OleDb.OleDbParameter(name, dataType);
			temp.Value = Value;
			return temp;
		}

		static public void RowUpdatedHandler(System.Data.OleDb.OleDbRowUpdatedEventArgs e, System.Data.DataSet current, System.Data.OleDb.OleDbDataAdapter AdapterToUse)
		{
			if (e.RecordsAffected == 0)
			{
				if (e.Errors is System.Data.DBConcurrencyException)
				{
					if (current.Tables[0].Rows.Count > 0 )
					{
						RecordConflict rcFrm = new RecordConflict();
						rcFrm.Compare(current.Tables[0].Rows[0], e.Row);

						rcFrm.ShowDialog();

						if (rcFrm.DialogResult != System.Windows.Forms.DialogResult.OK)
							e.Status = System.Data.UpdateStatus.SkipCurrentRow;

						rcFrm.Dispose();

						if (e.Status != System.Data.UpdateStatus.SkipCurrentRow)
						{
							current.Tables[0].Rows[0].BeginEdit();
							foreach (System.Data.DataColumn dc in current.Tables[0].Columns)
							{
								current.Tables[0].Rows[0][dc.ColumnName] = e.Row[dc.ColumnName];
							}
							current.Tables[0].Rows[0].EndEdit();
							AdapterToUse.Update(current, current.Tables[0].TableName);
							e.Status =  System.Data.UpdateStatus.Continue;
						}
					}
				}
			}
		}
	}
}
