using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;

using System.Windows.Forms;


namespace DebtManagerTest
{
	public class frmInvoices : DebtManagerTest.DebtBaseForm
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.DateTimePicker dateTimePicker1;
		private System.Windows.Forms.Label label2;
		private DebtManagerTest.InterfaceComponents.CompanyLookup companyLookup1;
		private System.Windows.Forms.Label label3;
		private DebtManagerTest.LookupComboObjects.LookupCombo lookupCombo1;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.DateTimePicker dateTimePicker2;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.TextBox textBox3;
		private System.Data.OleDb.OleDbDataAdapter daInvoices;
		private System.Data.OleDb.OleDbCommand oleDbSelectCommand1;
		private System.Data.OleDb.OleDbCommand oleDbInsertCommand1;
		private System.Data.OleDb.OleDbCommand oleDbUpdateCommand1;
		private System.Data.OleDb.OleDbCommand oleDbDeleteCommand1;
		private DebtManagerTest.dsInvoices dsInvoices1;
		private System.ComponentModel.IContainer components = null;

		public frmInvoices()
		{
			// This call is required by the Windows Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call
			this.mDs = dsInvoices1;
			this.daMain = daInvoices;
			this.mTableName = "Invoices";

			this.textBox2.DataBindings.Add(new CurrencyBinding("Text", this.dsInvoices1, "Invoices.Amount"));
			this.dateTimePicker2.DataBindings.Add(new DTPBinding("Checked", this.dsInvoices1, "Invoices.DatePaid"));
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.dateTimePicker1 = new System.Windows.Forms.DateTimePicker();
			this.dsInvoices1 = new DebtManagerTest.dsInvoices();
			this.label2 = new System.Windows.Forms.Label();
			this.companyLookup1 = new DebtManagerTest.InterfaceComponents.CompanyLookup();
			this.label3 = new System.Windows.Forms.Label();
			this.lookupCombo1 = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.label4 = new System.Windows.Forms.Label();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.textBox2 = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.dateTimePicker2 = new System.Windows.Forms.DateTimePicker();
			this.label7 = new System.Windows.Forms.Label();
			this.textBox3 = new System.Windows.Forms.TextBox();
			this.daInvoices = new System.Data.OleDb.OleDbDataAdapter();
			this.oleDbDeleteCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbInsertCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbUpdateCommand1 = new System.Data.OleDb.OleDbCommand();
			this.tabControl1.SuspendLayout();
			this.tabGeneral.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dsInvoices1)).BeginInit();
			this.SuspendLayout();
			// 
			// tabControl1
			// 
			this.tabControl1.Size = new System.Drawing.Size(328, 266);
			this.tabControl1.Visible = true;
			// 
			// tabGeneral
			// 
			this.tabGeneral.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.textBox3,
																					 this.label7,
																					 this.dateTimePicker2,
																					 this.label6,
																					 this.textBox2,
																					 this.label5,
																					 this.textBox1,
																					 this.label4,
																					 this.lookupCombo1,
																					 this.label3,
																					 this.companyLookup1,
																					 this.label2,
																					 this.dateTimePicker1,
																					 this.label1});
			this.tabGeneral.Size = new System.Drawing.Size(328, 241);
			this.tabGeneral.Visible = true;
			// 
			// lblStatus
			// 
			this.lblStatus.Location = new System.Drawing.Point(9, 277);
			this.lblStatus.Visible = true;
			// 
			// cmdOK
			// 
			this.cmdOK.Location = new System.Drawing.Point(178, 280);
			this.cmdOK.Visible = true;
			// 
			// cmdCancel
			// 
			this.cmdCancel.Location = new System.Drawing.Point(253, 280);
			this.cmdCancel.Visible = true;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(27, 20);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(83, 12);
			this.label1.TabIndex = 0;
			this.label1.Text = "Invoice Date";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// dateTimePicker1
			// 
			this.dateTimePicker1.DataBindings.Add(new System.Windows.Forms.Binding("Value", this.dsInvoices1, "Invoices.InvoiceDate"));
			this.dateTimePicker1.Format = System.Windows.Forms.DateTimePickerFormat.Short;
			this.dateTimePicker1.Location = new System.Drawing.Point(127, 16);
			this.dateTimePicker1.Name = "dateTimePicker1";
			this.dateTimePicker1.Size = new System.Drawing.Size(151, 20);
			this.dateTimePicker1.TabIndex = 1;
			// 
			// dsInvoices1
			// 
			this.dsInvoices1.DataSetName = "dsInvoices";
			this.dsInvoices1.Locale = new System.Globalization.CultureInfo("en-GB");
			this.dsInvoices1.Namespace = "http://www.tempuri.org/dsInvoices.xsd";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(27, 44);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(83, 12);
			this.label2.TabIndex = 2;
			this.label2.Text = "Invoice From";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// companyLookup1
			// 
			this.companyLookup1.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsInvoices1, "Invoices.InvoiceSource"));
			this.companyLookup1.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.companyLookup1.Location = new System.Drawing.Point(127, 40);
			this.companyLookup1.Name = "companyLookup1";
			this.companyLookup1.Size = new System.Drawing.Size(151, 21);
			this.companyLookup1.TabIndex = 3;
			this.companyLookup1.ValidForCreditor = false;
			this.companyLookup1.ValidForEmployer = false;
			this.companyLookup1.ValidForEndowmentCompany = false;
			this.companyLookup1.ValidForEstateAgent = false;
			this.companyLookup1.ValidForHousingAssociation = false;
			this.companyLookup1.ValidForIndemnityCompany = false;
			this.companyLookup1.ValidForInvoiceSource = true;
			this.companyLookup1.ValidForSecondCharge = false;
			this.companyLookup1.ValidForValuer = false;
			this.companyLookup1.zDataBound = true;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(27, 68);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(83, 12);
			this.label3.TabIndex = 4;
			this.label3.Text = "Invoice Type";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lookupCombo1
			// 
			this.lookupCombo1.AllowUpdates = true;
			this.lookupCombo1.ComboValue = null;
			this.lookupCombo1.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsInvoices1, "Invoices.InvoiceType"));
			this.lookupCombo1.DataBound = true;
			this.lookupCombo1.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.lookupCombo1.ExtraRefreshes = true;
			this.lookupCombo1.Location = new System.Drawing.Point(127, 65);
			this.lookupCombo1.LookupID = "InvoiceType";
			this.lookupCombo1.Name = "lookupCombo1";
			this.lookupCombo1.Nullable = true;
			this.lookupCombo1.Size = new System.Drawing.Size(151, 21);
			this.lookupCombo1.TabIndex = 5;
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(27, 92);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(83, 12);
			this.label4.TabIndex = 6;
			this.label4.Text = "Reference";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// textBox1
			// 
			this.textBox1.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsInvoices1, "Invoices.InvoiceNo"));
			this.textBox1.Location = new System.Drawing.Point(127, 90);
			this.textBox1.MaxLength = 50;
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(151, 20);
			this.textBox1.TabIndex = 7;
			this.textBox1.Text = "";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(27, 116);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(83, 12);
			this.label5.TabIndex = 8;
			this.label5.Text = "Amount";
			this.label5.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// textBox2
			// 
			this.textBox2.Location = new System.Drawing.Point(127, 114);
			this.textBox2.Name = "textBox2";
			this.textBox2.Size = new System.Drawing.Size(83, 20);
			this.textBox2.TabIndex = 9;
			this.textBox2.Text = "";
			this.textBox2.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(27, 140);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(83, 12);
			this.label6.TabIndex = 10;
			this.label6.Text = "Date Paid";
			this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// dateTimePicker2
			// 
			this.dateTimePicker2.Checked = false;
			this.dateTimePicker2.Format = System.Windows.Forms.DateTimePickerFormat.Short;
			this.dateTimePicker2.Location = new System.Drawing.Point(127, 138);
			this.dateTimePicker2.Name = "dateTimePicker2";
			this.dateTimePicker2.ShowCheckBox = true;
			this.dateTimePicker2.Size = new System.Drawing.Size(151, 20);
			this.dateTimePicker2.TabIndex = 11;
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(27, 164);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(83, 12);
			this.label7.TabIndex = 12;
			this.label7.Text = "Comments";
			this.label7.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// textBox3
			// 
			this.textBox3.AcceptsReturn = true;
			this.textBox3.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsInvoices1, "Invoices.Comments"));
			this.textBox3.Location = new System.Drawing.Point(127, 162);
			this.textBox3.MaxLength = 255;
			this.textBox3.Multiline = true;
			this.textBox3.Name = "textBox3";
			this.textBox3.Size = new System.Drawing.Size(151, 62);
			this.textBox3.TabIndex = 13;
			this.textBox3.Text = "";
			// 
			// daInvoices
			// 
			this.daInvoices.DeleteCommand = this.oleDbDeleteCommand1;
			this.daInvoices.InsertCommand = this.oleDbInsertCommand1;
			this.daInvoices.SelectCommand = this.oleDbSelectCommand1;
			this.daInvoices.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																								 new System.Data.Common.DataTableMapping("Table", "Invoices", new System.Data.Common.DataColumnMapping[] {
																																																			 new System.Data.Common.DataColumnMapping("Amount", "Amount"),
																																																			 new System.Data.Common.DataColumnMapping("CaseID", "CaseID"),
																																																			 new System.Data.Common.DataColumnMapping("Comments", "Comments"),
																																																			 new System.Data.Common.DataColumnMapping("Created", "Created"),
																																																			 new System.Data.Common.DataColumnMapping("CreateUser", "CreateUser"),
																																																			 new System.Data.Common.DataColumnMapping("DatePaid", "DatePaid"),
																																																			 new System.Data.Common.DataColumnMapping("ID", "ID"),
																																																			 new System.Data.Common.DataColumnMapping("InvoiceDate", "InvoiceDate"),
																																																			 new System.Data.Common.DataColumnMapping("InvoiceNo", "InvoiceNo"),
																																																			 new System.Data.Common.DataColumnMapping("InvoiceSource", "InvoiceSource"),
																																																			 new System.Data.Common.DataColumnMapping("InvoiceType", "InvoiceType"),
																																																			 new System.Data.Common.DataColumnMapping("LastUpdated", "LastUpdated"),
																																																			 new System.Data.Common.DataColumnMapping("LastUser", "LastUser")})});
			this.daInvoices.UpdateCommand = this.oleDbUpdateCommand1;
			// 
			// oleDbDeleteCommand1
			// 
			this.oleDbDeleteCommand1.CommandText = "DELETE FROM Invoices WHERE (ID = ?) AND (LastUpdated = ? OR LastUpdated IS NULL A" +
				"ND ? IS NULL)";
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Param3", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			// 
			// oleDbInsertCommand1
			// 
			this.oleDbInsertCommand1.CommandText = "INSERT INTO Invoices(Amount, CaseID, Comments, Created, CreateUser, DatePaid, Inv" +
				"oiceDate, InvoiceNo, InvoiceSource, InvoiceType, LastUpdated, LastUser) VALUES (" +
				"?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Amount", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "Amount", System.Data.DataRowVersion.Current, null));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("CaseID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "CaseID", System.Data.DataRowVersion.Current, null));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Comments", System.Data.OleDb.OleDbType.VarWChar, 255, "Comments"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Created", System.Data.OleDb.OleDbType.DBDate, 0, "Created"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("CreateUser", System.Data.OleDb.OleDbType.VarWChar, 12, "CreateUser"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("DatePaid", System.Data.OleDb.OleDbType.DBDate, 0, "DatePaid"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("InvoiceDate", System.Data.OleDb.OleDbType.DBDate, 0, "InvoiceDate"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("InvoiceNo", System.Data.OleDb.OleDbType.VarWChar, 50, "InvoiceNo"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("InvoiceSource", System.Data.OleDb.OleDbType.VarWChar, 10, "InvoiceSource"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("InvoiceType", System.Data.OleDb.OleDbType.VarWChar, 20, "InvoiceType"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, "LastUpdated"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar, 12, "LastUser"));
			// 
			// oleDbSelectCommand1
			// 
			this.oleDbSelectCommand1.CommandText = "SELECT Amount, CaseID, Comments, Created, CreateUser, DatePaid, ID, InvoiceDate, " +
				"InvoiceNo, InvoiceSource, InvoiceType, LastUpdated, LastUser FROM Invoices WHERE" +
				" (ID = ?)";
			this.oleDbSelectCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Current, null));
			// 
			// oleDbUpdateCommand1
			// 
			this.oleDbUpdateCommand1.CommandText = @"UPDATE Invoices SET Amount = ?, CaseID = ?, Comments = ?, Created = ?, CreateUser = ?, DatePaid = ?, InvoiceDate = ?, InvoiceNo = ?, InvoiceSource = ?, InvoiceType = ?, LastUpdated = ?, LastUser = ? WHERE (ID = ?) AND (LastUpdated = ? OR LastUpdated IS NULL AND ? IS NULL)";
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Amount", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "Amount", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("CaseID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "CaseID", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Comments", System.Data.OleDb.OleDbType.VarWChar, 255, "Comments"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Created", System.Data.OleDb.OleDbType.DBDate, 0, "Created"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("CreateUser", System.Data.OleDb.OleDbType.VarWChar, 12, "CreateUser"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("DatePaid", System.Data.OleDb.OleDbType.DBDate, 0, "DatePaid"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("InvoiceDate", System.Data.OleDb.OleDbType.DBDate, 0, "InvoiceDate"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("InvoiceNo", System.Data.OleDb.OleDbType.VarWChar, 50, "InvoiceNo"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("InvoiceSource", System.Data.OleDb.OleDbType.VarWChar, 10, "InvoiceSource"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("InvoiceType", System.Data.OleDb.OleDbType.VarWChar, 20, "InvoiceType"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, "LastUpdated"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar, 12, "LastUser"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Param75", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			// 
			// frmInvoices
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(328, 310);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.tabControl1,
																		  this.lblStatus,
																		  this.cmdOK,
																		  this.cmdCancel});
			this.Name = "frmInvoices";
			this.Text = "Invoice Details";
			this.tabControl1.ResumeLayout(false);
			this.tabGeneral.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.dsInvoices1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion
				
		public override void AddNew(int CaseID)
		{
			base.AddNew(CaseID);
			dsInvoices1.Invoices.Rows[0].BeginEdit();
			dsInvoices1.Invoices.Rows[0]["InvoiceDate"] = DateTime.Today;
			dsInvoices1.Invoices.Rows[0].EndEdit();
		}
	}
}

