using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;

using System.Windows.Forms;


namespace DebtManagerTest
{
	public class frmValuations : DebtManagerTest.DebtBaseForm
	{
		private System.Windows.Forms.Label lblValuationType;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboValuationType;
		private System.Windows.Forms.Label lblValuer;
		private DebtManagerTest.InterfaceComponents.CompanyLookup cboValuer;
		private System.Windows.Forms.Label lblInstructed;
		private System.Windows.Forms.DateTimePicker dtpInstructed;
		private System.Windows.Forms.Label lblValuationFee;
		private System.Windows.Forms.TextBox txtValuationFee;
		private System.Windows.Forms.Label lblValuation;
		private System.Windows.Forms.TextBox txtValuation;
		private System.Windows.Forms.Label lblValuationDate;
		private System.Windows.Forms.DateTimePicker dtpValuationDate;
		private System.Windows.Forms.Label lblReplyReferred;
		private System.Windows.Forms.DateTimePicker dtpReplyReferred;
		private System.Windows.Forms.Label lblERP;
		private System.Windows.Forms.TextBox txtERP;
		private System.Windows.Forms.Label lblERRP;
		private System.Windows.Forms.TextBox txtERRP;
		private System.Data.OleDb.OleDbDataAdapter daValuations;
		private System.Data.OleDb.OleDbCommand oleDbSelectCommand1;
		private System.Data.OleDb.OleDbCommand oleDbInsertCommand1;
		private System.Data.OleDb.OleDbCommand oleDbUpdateCommand1;
		private System.Data.OleDb.OleDbCommand oleDbDeleteCommand1;
		private DebtManagerTest.dsValuations dsValuations1;
		private System.ComponentModel.IContainer components = null;
		private bool finishedLoading = false;

		public frmValuations()
		{
			// This call is required by the Windows Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call
			this.daMain = daValuations;
			this.mDs = dsValuations1;
			this.mTableName = "Valuations";

			this.dtpInstructed.DataBindings.Add(new DTPBinding("Checked", this.dsValuations1, "Valuations.DateInstructed"));
			this.txtValuationFee.DataBindings.Add(new CurrencyBinding("Text", this.dsValuations1, "Valuations.ValuationFee"));
			this.txtValuation.DataBindings.Add(new CurrencyBinding("Text", this.dsValuations1, "Valuations.Valuation"));
			this.dtpReplyReferred.DataBindings.Add(new DTPBinding("Checked", this.dsValuations1, "Valuations.ReplyReferred"));
			this.txtERP.DataBindings.Add(new CurrencyBinding("Text", this.dsValuations1, "Valuations.ERP"));
			this.txtERRP.DataBindings.Add(new CurrencyBinding("Text", this.dsValuations1, "Valuations.ERRP"));
			finishedLoading = true;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lblValuationType = new System.Windows.Forms.Label();
			this.cboValuationType = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.dsValuations1 = new DebtManagerTest.dsValuations();
			this.lblValuer = new System.Windows.Forms.Label();
			this.cboValuer = new DebtManagerTest.InterfaceComponents.CompanyLookup();
			this.lblInstructed = new System.Windows.Forms.Label();
			this.dtpInstructed = new System.Windows.Forms.DateTimePicker();
			this.lblValuationFee = new System.Windows.Forms.Label();
			this.txtValuationFee = new System.Windows.Forms.TextBox();
			this.lblValuation = new System.Windows.Forms.Label();
			this.txtValuation = new System.Windows.Forms.TextBox();
			this.lblValuationDate = new System.Windows.Forms.Label();
			this.dtpValuationDate = new System.Windows.Forms.DateTimePicker();
			this.lblReplyReferred = new System.Windows.Forms.Label();
			this.dtpReplyReferred = new System.Windows.Forms.DateTimePicker();
			this.lblERP = new System.Windows.Forms.Label();
			this.txtERP = new System.Windows.Forms.TextBox();
			this.lblERRP = new System.Windows.Forms.Label();
			this.txtERRP = new System.Windows.Forms.TextBox();
			this.daValuations = new System.Data.OleDb.OleDbDataAdapter();
			this.oleDbDeleteCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbInsertCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbUpdateCommand1 = new System.Data.OleDb.OleDbCommand();
			this.tabControl1.SuspendLayout();
			this.tabGeneral.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dsValuations1)).BeginInit();
			this.SuspendLayout();
			// 
			// tabControl1
			// 
			this.tabControl1.Size = new System.Drawing.Size(337, 268);
			this.tabControl1.Visible = true;
			// 
			// tabGeneral
			// 
			this.tabGeneral.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.txtERRP,
																					 this.lblERRP,
																					 this.txtERP,
																					 this.lblERP,
																					 this.dtpReplyReferred,
																					 this.dtpInstructed,
																					 this.lblReplyReferred,
																					 this.dtpValuationDate,
																					 this.lblValuationDate,
																					 this.txtValuation,
																					 this.lblValuation,
																					 this.txtValuationFee,
																					 this.lblValuationFee,
																					 this.lblInstructed,
																					 this.cboValuer,
																					 this.lblValuer,
																					 this.cboValuationType,
																					 this.lblValuationType});
			this.tabGeneral.Size = new System.Drawing.Size(337, 243);
			this.tabGeneral.Visible = true;
			// 
			// lblStatus
			// 
			this.lblStatus.Location = new System.Drawing.Point(6, 274);
			this.lblStatus.Visible = true;
			// 
			// cmdOK
			// 
			this.cmdOK.Location = new System.Drawing.Point(175, 277);
			this.cmdOK.Visible = true;
			// 
			// cmdCancel
			// 
			this.cmdCancel.Location = new System.Drawing.Point(250, 277);
			this.cmdCancel.Visible = true;
			// 
			// lblValuationType
			// 
			this.lblValuationType.Location = new System.Drawing.Point(12, 13);
			this.lblValuationType.Name = "lblValuationType";
			this.lblValuationType.Size = new System.Drawing.Size(100, 16);
			this.lblValuationType.TabIndex = 0;
			this.lblValuationType.Text = "Valuation Type";
			this.lblValuationType.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// cboValuationType
			// 
			this.cboValuationType.AllowUpdates = false;
			this.cboValuationType.ComboValue = null;
			this.cboValuationType.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsValuations1, "Valuations.ValuationType"));
			this.cboValuationType.DataBound = true;
			this.cboValuationType.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboValuationType.ExtraRefreshes = true;
			this.cboValuationType.Location = new System.Drawing.Point(134, 10);
			this.cboValuationType.LookupID = "ValuationType";
			this.cboValuationType.Name = "cboValuationType";
			this.cboValuationType.Nullable = false;
			this.cboValuationType.Size = new System.Drawing.Size(131, 21);
			this.cboValuationType.TabIndex = 1;
			// 
			// dsValuations1
			// 
			this.dsValuations1.DataSetName = "dsValuations";
			this.dsValuations1.Locale = new System.Globalization.CultureInfo("en-GB");
			this.dsValuations1.Namespace = "http://www.tempuri.org/dsValuations.xsd";
			// 
			// lblValuer
			// 
			this.lblValuer.Location = new System.Drawing.Point(12, 37);
			this.lblValuer.Name = "lblValuer";
			this.lblValuer.Size = new System.Drawing.Size(100, 16);
			this.lblValuer.TabIndex = 2;
			this.lblValuer.Text = "Valuer";
			this.lblValuer.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.lblValuer.Visible = false;
			// 
			// cboValuer
			// 
			this.cboValuer.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsValuations1, "Valuations.Valuer"));
			this.cboValuer.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboValuer.Location = new System.Drawing.Point(134, 35);
			this.cboValuer.Name = "cboValuer";
			this.cboValuer.Size = new System.Drawing.Size(131, 21);
			this.cboValuer.TabIndex = 3;
			this.cboValuer.ValidForCreditor = false;
			this.cboValuer.ValidForEmployer = false;
			this.cboValuer.ValidForEndowmentCompany = false;
			this.cboValuer.ValidForEstateAgent = false;
			this.cboValuer.ValidForHousingAssociation = false;
			this.cboValuer.ValidForIndemnityCompany = false;
			this.cboValuer.ValidForInvoiceSource = false;
			this.cboValuer.ValidForSecondCharge = false;
			this.cboValuer.ValidForValuer = true;
			this.cboValuer.Visible = false;
			this.cboValuer.zDataBound = true;
			// 
			// lblInstructed
			// 
			this.lblInstructed.Location = new System.Drawing.Point(12, 61);
			this.lblInstructed.Name = "lblInstructed";
			this.lblInstructed.Size = new System.Drawing.Size(100, 16);
			this.lblInstructed.TabIndex = 4;
			this.lblInstructed.Text = "Date Instructed";
			this.lblInstructed.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.lblInstructed.Visible = false;
			// 
			// dtpInstructed
			// 
			this.dtpInstructed.Checked = false;
			this.dtpInstructed.Format = System.Windows.Forms.DateTimePickerFormat.Short;
			this.dtpInstructed.Location = new System.Drawing.Point(134, 60);
			this.dtpInstructed.Name = "dtpInstructed";
			this.dtpInstructed.ShowCheckBox = true;
			this.dtpInstructed.Size = new System.Drawing.Size(131, 20);
			this.dtpInstructed.TabIndex = 5;
			this.dtpInstructed.Visible = false;
			// 
			// lblValuationFee
			// 
			this.lblValuationFee.Location = new System.Drawing.Point(12, 85);
			this.lblValuationFee.Name = "lblValuationFee";
			this.lblValuationFee.Size = new System.Drawing.Size(100, 16);
			this.lblValuationFee.TabIndex = 6;
			this.lblValuationFee.Text = "Valuation Fee";
			this.lblValuationFee.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.lblValuationFee.Visible = false;
			// 
			// txtValuationFee
			// 
			this.txtValuationFee.Location = new System.Drawing.Point(134, 84);
			this.txtValuationFee.Name = "txtValuationFee";
			this.txtValuationFee.Size = new System.Drawing.Size(113, 20);
			this.txtValuationFee.TabIndex = 7;
			this.txtValuationFee.Text = "";
			this.txtValuationFee.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.txtValuationFee.Visible = false;
			// 
			// lblValuation
			// 
			this.lblValuation.Location = new System.Drawing.Point(12, 109);
			this.lblValuation.Name = "lblValuation";
			this.lblValuation.Size = new System.Drawing.Size(100, 16);
			this.lblValuation.TabIndex = 8;
			this.lblValuation.Text = "Valuation";
			this.lblValuation.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.lblValuation.Visible = false;
			// 
			// txtValuation
			// 
			this.txtValuation.Location = new System.Drawing.Point(134, 108);
			this.txtValuation.Name = "txtValuation";
			this.txtValuation.Size = new System.Drawing.Size(113, 20);
			this.txtValuation.TabIndex = 9;
			this.txtValuation.Text = "";
			this.txtValuation.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.txtValuation.Visible = false;
			// 
			// lblValuationDate
			// 
			this.lblValuationDate.Location = new System.Drawing.Point(12, 133);
			this.lblValuationDate.Name = "lblValuationDate";
			this.lblValuationDate.Size = new System.Drawing.Size(100, 16);
			this.lblValuationDate.TabIndex = 10;
			this.lblValuationDate.Text = "Valuation Date";
			this.lblValuationDate.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.lblValuationDate.Visible = false;
			// 
			// dtpValuationDate
			// 
			this.dtpValuationDate.DataBindings.Add(new System.Windows.Forms.Binding("Value", this.dsValuations1, "Valuations.ValuationDate"));
			this.dtpValuationDate.Format = System.Windows.Forms.DateTimePickerFormat.Short;
			this.dtpValuationDate.Location = new System.Drawing.Point(134, 132);
			this.dtpValuationDate.Name = "dtpValuationDate";
			this.dtpValuationDate.Size = new System.Drawing.Size(131, 20);
			this.dtpValuationDate.TabIndex = 11;
			this.dtpValuationDate.Visible = false;
			// 
			// lblReplyReferred
			// 
			this.lblReplyReferred.Location = new System.Drawing.Point(12, 157);
			this.lblReplyReferred.Name = "lblReplyReferred";
			this.lblReplyReferred.Size = new System.Drawing.Size(100, 16);
			this.lblReplyReferred.TabIndex = 12;
			this.lblReplyReferred.Text = "Reply Referred";
			this.lblReplyReferred.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.lblReplyReferred.Visible = false;
			// 
			// dtpReplyReferred
			// 
			this.dtpReplyReferred.Checked = false;
			this.dtpReplyReferred.Format = System.Windows.Forms.DateTimePickerFormat.Short;
			this.dtpReplyReferred.Location = new System.Drawing.Point(134, 156);
			this.dtpReplyReferred.Name = "dtpReplyReferred";
			this.dtpReplyReferred.ShowCheckBox = true;
			this.dtpReplyReferred.Size = new System.Drawing.Size(131, 20);
			this.dtpReplyReferred.TabIndex = 13;
			this.dtpReplyReferred.Visible = false;
			// 
			// lblERP
			// 
			this.lblERP.Location = new System.Drawing.Point(12, 181);
			this.lblERP.Name = "lblERP";
			this.lblERP.Size = new System.Drawing.Size(100, 16);
			this.lblERP.TabIndex = 14;
			this.lblERP.Text = "ERP";
			this.lblERP.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.lblERP.Visible = false;
			// 
			// txtERP
			// 
			this.txtERP.Location = new System.Drawing.Point(134, 180);
			this.txtERP.Name = "txtERP";
			this.txtERP.Size = new System.Drawing.Size(113, 20);
			this.txtERP.TabIndex = 15;
			this.txtERP.Text = "";
			this.txtERP.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.txtERP.Visible = false;
			// 
			// lblERRP
			// 
			this.lblERRP.Location = new System.Drawing.Point(12, 205);
			this.lblERRP.Name = "lblERRP";
			this.lblERRP.Size = new System.Drawing.Size(100, 16);
			this.lblERRP.TabIndex = 16;
			this.lblERRP.Text = "ERRP";
			this.lblERRP.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.lblERRP.Visible = false;
			// 
			// txtERRP
			// 
			this.txtERRP.Location = new System.Drawing.Point(134, 204);
			this.txtERRP.Name = "txtERRP";
			this.txtERRP.Size = new System.Drawing.Size(113, 20);
			this.txtERRP.TabIndex = 17;
			this.txtERRP.Text = "";
			this.txtERRP.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.txtERRP.Visible = false;
			// 
			// daValuations
			// 
			this.daValuations.DeleteCommand = this.oleDbDeleteCommand1;
			this.daValuations.InsertCommand = this.oleDbInsertCommand1;
			this.daValuations.SelectCommand = this.oleDbSelectCommand1;
			this.daValuations.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																								   new System.Data.Common.DataTableMapping("Table", "Valuations", new System.Data.Common.DataColumnMapping[] {
																																																				 new System.Data.Common.DataColumnMapping("Valuer", "Valuer"),
																																																				 new System.Data.Common.DataColumnMapping("ValuationType", "ValuationType"),
																																																				 new System.Data.Common.DataColumnMapping("ValuationFee", "ValuationFee"),
																																																				 new System.Data.Common.DataColumnMapping("ValuationDate", "ValuationDate"),
																																																				 new System.Data.Common.DataColumnMapping("Valuation", "Valuation"),
																																																				 new System.Data.Common.DataColumnMapping("ReplyReferred", "ReplyReferred"),
																																																				 new System.Data.Common.DataColumnMapping("LastUser", "LastUser"),
																																																				 new System.Data.Common.DataColumnMapping("LastUpdated", "LastUpdated"),
																																																				 new System.Data.Common.DataColumnMapping("ID", "ID"),
																																																				 new System.Data.Common.DataColumnMapping("ERRP", "ERRP"),
																																																				 new System.Data.Common.DataColumnMapping("ERP", "ERP"),
																																																				 new System.Data.Common.DataColumnMapping("DateInstructed", "DateInstructed"),
																																																				 new System.Data.Common.DataColumnMapping("CreateUser", "CreateUser"),
																																																				 new System.Data.Common.DataColumnMapping("Created", "Created"),
																																																				 new System.Data.Common.DataColumnMapping("CaseID", "CaseID")})});
			this.daValuations.UpdateCommand = this.oleDbUpdateCommand1;
			// 
			// oleDbDeleteCommand1
			// 
			this.oleDbDeleteCommand1.CommandText = "DELETE FROM Valuations WHERE (ID = ?) AND (LastUpdated = ? OR LastUpdated IS NULL" +
				" AND ? IS NULL)";
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Param3", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			// 
			// oleDbInsertCommand1
			// 
			this.oleDbInsertCommand1.CommandText = "INSERT INTO Valuations(Valuer, ValuationType, ValuationFee, ValuationDate, Valuat" +
				"ion, ReplyReferred, LastUser, LastUpdated, ERRP, ERP, DateInstructed, CreateUser" +
				", Created, CaseID) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Valuer", System.Data.OleDb.OleDbType.VarWChar, 10, "Valuer"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValuationType", System.Data.OleDb.OleDbType.VarWChar, 1, "ValuationType"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValuationFee", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "ValuationFee", System.Data.DataRowVersion.Current, null));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValuationDate", System.Data.OleDb.OleDbType.DBDate, 0, "ValuationDate"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Valuation", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "Valuation", System.Data.DataRowVersion.Current, null));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ReplyReferred", System.Data.OleDb.OleDbType.DBDate, 0, "ReplyReferred"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar, 12, "LastUser"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, "LastUpdated"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ERRP", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "ERRP", System.Data.DataRowVersion.Current, null));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ERP", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "ERP", System.Data.DataRowVersion.Current, null));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("DateInstructed", System.Data.OleDb.OleDbType.DBDate, 0, "DateInstructed"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("CreateUser", System.Data.OleDb.OleDbType.VarWChar, 12, "CreateUser"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Created", System.Data.OleDb.OleDbType.DBDate, 0, "Created"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("CaseID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "CaseID", System.Data.DataRowVersion.Current, null));
			// 
			// oleDbSelectCommand1
			// 
			this.oleDbSelectCommand1.CommandText = "SELECT Valuer, ValuationType, ValuationFee, ValuationDate, Valuation, ReplyReferr" +
				"ed, LastUser, LastUpdated, ID, ERRP, ERP, DateInstructed, CreateUser, Created, C" +
				"aseID FROM Valuations WHERE (ID = ?)";
			this.oleDbSelectCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Current, null));
			// 
			// oleDbUpdateCommand1
			// 
			this.oleDbUpdateCommand1.CommandText = @"UPDATE Valuations SET Valuer = ?, ValuationType = ?, ValuationFee = ?, ValuationDate = ?, Valuation = ?, ReplyReferred = ?, LastUser = ?, LastUpdated = ?, ERRP = ?, ERP = ?, DateInstructed = ?, CreateUser = ?, Created = ?, CaseID = ? WHERE (ID = ?) AND (LastUpdated = ? OR LastUpdated IS NULL AND ? IS NULL)";
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Valuer", System.Data.OleDb.OleDbType.VarWChar, 10, "Valuer"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValuationType", System.Data.OleDb.OleDbType.VarWChar, 1, "ValuationType"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValuationFee", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "ValuationFee", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValuationDate", System.Data.OleDb.OleDbType.DBDate, 0, "ValuationDate"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Valuation", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "Valuation", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ReplyReferred", System.Data.OleDb.OleDbType.DBDate, 0, "ReplyReferred"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar, 12, "LastUser"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, "LastUpdated"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ERRP", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "ERRP", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ERP", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "ERP", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("DateInstructed", System.Data.OleDb.OleDbType.DBDate, 0, "DateInstructed"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("CreateUser", System.Data.OleDb.OleDbType.VarWChar, 12, "CreateUser"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Created", System.Data.OleDb.OleDbType.DBDate, 0, "Created"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("CaseID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "CaseID", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Param85", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			// 
			// frmValuations
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(337, 310);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.tabControl1,
																		  this.lblStatus,
																		  this.cmdOK,
																		  this.cmdCancel});
			this.Name = "frmValuations";
			this.Text = "Valuation Details";
			this.Load += new System.EventHandler(this.frmValuations_Load);
			this.tabControl1.ResumeLayout(false);
			this.tabGeneral.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.dsValuations1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void cboValuationType_SelectedValueChanged(object sender, System.EventArgs e)
		{
			switch(cboValuationType.SelectedValue.ToString())
			{
				case "P":
					lblValuer.Visible = true;
					cboValuer.Visible = true;
					lblInstructed.Visible = true;
					lblInstructed.Text = "Date Instructed";
					dtpInstructed.Visible = true;
					lblValuationFee.Visible = true;
					txtValuationFee.Visible = true;
					lblValuation.Visible = true;
					txtValuation.Visible = true;
					lblValuationDate.Visible = true;
					dtpValuationDate.Visible = true;
					lblReplyReferred.Visible = false;
					dtpReplyReferred.Visible = false;
					lblERP.Visible = true;
					txtERP.Visible = true;
					lblERRP.Visible = true;
					txtERRP.Visible = true;

					dsValuations1.Valuations.Rows[0].BeginEdit();
					dsValuations1.Valuations.Rows[0]["ReplyReferred"] = DBNull.Value;
					dsValuations1.Valuations.Rows[0]["ValuationType"] = cboValuationType.SelectedValue;
					dsValuations1.Valuations.Rows[0].EndEdit();

					break;
				case "O":
					lblValuer.Visible = true;
					cboValuer.Visible = true;
					lblInstructed.Visible = true;
					lblInstructed.Text = "Date Contacted";
					dtpInstructed.Visible = true;
					lblValuationFee.Visible = false;
					txtValuationFee.Visible = false;
					lblValuation.Visible = true;
					txtValuation.Visible = true;
					lblValuationDate.Visible = true;
					dtpValuationDate.Visible = true;
					lblReplyReferred.Visible = true;
					dtpReplyReferred.Visible = true;
					lblERP.Visible = false;
					txtERP.Visible = false;
					lblERRP.Visible = false;
					txtERRP.Visible = false;

					dsValuations1.Valuations.Rows[0].BeginEdit();
					dsValuations1.Valuations.Rows[0]["ERP"] = DBNull.Value;
					dsValuations1.Valuations.Rows[0]["ERRP"] = DBNull.Value;
					dsValuations1.Valuations.Rows[0]["ValuationFee"] = DBNull.Value;
					dsValuations1.Valuations.Rows[0]["ValuationType"] = cboValuationType.SelectedValue;
					dsValuations1.Valuations.Rows[0].EndEdit();
					
					break;
				case "M":
					lblValuer.Visible = false;
					cboValuer.Visible = false;
					lblInstructed.Visible = false;
					lblInstructed.Text = "Date Instructed";
					dtpInstructed.Visible = false;
					lblValuationFee.Visible = false;
					txtValuationFee.Visible = false;
					lblValuation.Visible = true;
					txtValuation.Visible = true;
					lblValuationDate.Visible = true;
					dtpValuationDate.Visible = true;
					lblReplyReferred.Visible = false;
					dtpReplyReferred.Visible = false;
					lblERP.Visible = false;
					txtERP.Visible = false;
					lblERRP.Visible = false;
					txtERRP.Visible = false;
					
					dsValuations1.Valuations.Rows[0].BeginEdit();
					dsValuations1.Valuations.Rows[0]["Valuer"] = DBNull.Value;
					dsValuations1.Valuations.Rows[0]["DateInstructed"] = DBNull.Value;
					dsValuations1.Valuations.Rows[0]["ReplyReferred"] = DBNull.Value;
					dsValuations1.Valuations.Rows[0]["ERP"] = DBNull.Value;
					dsValuations1.Valuations.Rows[0]["ERRP"] = DBNull.Value;
					dsValuations1.Valuations.Rows[0]["ValuationFee"] = DBNull.Value;
					dsValuations1.Valuations.Rows[0]["ValuationType"] = cboValuationType.SelectedValue;
					dsValuations1.Valuations.Rows[0].EndEdit();

					break;
				case "R":
					lblValuer.Visible = true;
					cboValuer.Visible = true;
					lblInstructed.Visible = true;
					lblInstructed.Text = "Date Contacted";
					dtpInstructed.Visible = true;
					lblValuationFee.Visible = false;
					txtValuationFee.Visible = false;
					lblValuation.Visible = true;
					txtValuation.Visible = true;
					lblValuationDate.Visible = true;
					dtpValuationDate.Visible = true;
					lblReplyReferred.Visible = true;
					dtpReplyReferred.Visible = true;
					lblERP.Visible = false;
					txtERP.Visible = false;
					lblERRP.Visible = false;
					txtERRP.Visible = false;
					
					dsValuations1.Valuations.Rows[0].BeginEdit();
					dsValuations1.Valuations.Rows[0]["ERP"] = DBNull.Value;
					dsValuations1.Valuations.Rows[0]["ERRP"] = DBNull.Value;
					dsValuations1.Valuations.Rows[0]["ValuationFee"] = DBNull.Value;
					dsValuations1.Valuations.Rows[0]["ValuationType"] = cboValuationType.SelectedValue;
					dsValuations1.Valuations.Rows[0].EndEdit();

					break;
			}
		}

		public override void AddNew(int CaseID)
		{
			base.AddNew(CaseID);
			dsValuations1.Valuations.Rows[0].BeginEdit();
			dsValuations1.Valuations.Rows[0]["ValuationDate"] = DateTime.Today;
			dsValuations1.Valuations.Rows[0].EndEdit();
		}

		private void frmValuations_Load(object sender, System.EventArgs e)
		{
			this.cboValuationType.SelectedValueChanged += new System.EventHandler(this.cboValuationType_SelectedValueChanged);
			if (!this.Adding)
			{
				cboValuationType_SelectedValueChanged(this, null);
			}
		}
	}
}

