using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for frmUser.
	/// </summary>
	public class frmUser : System.Windows.Forms.Form
	{
		private Crownwood.Magic.Controls.TabControl tabControl1;
		private Crownwood.Magic.Controls.TabPage tabPage1;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboLevel;
		private System.Windows.Forms.TextBox txtPassword;
		private System.Windows.Forms.TextBox txtUserName;
		private UtilityLibrary.WinControls.ButtonEx cmdOK;
		private UtilityLibrary.WinControls.ButtonEx cmdCancel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		public dsUsers users;
		private dsUsers.UsersRow userRow;

		public frmUser()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		public frmUser(dsUsers.UsersRow User): this()
		{
			users = new dsUsers();
			if(User == null)
			{
				userRow = users.Users.NewUsersRow();
				users.Users.AddUsersRow(userRow);
			}
			else
			{
				users.Users.ImportRow(User);
				this.txtPassword.Enabled = false;
			}

			this.tabPage1.BindingContext = this.BindingContext;
			this.txtUserName.DataBindings.Add(new Binding("Text", users, "Users.UserName"));
			this.txtPassword.DataBindings.Add(new Binding("Text", users, "Users.Password"));
			this.cboLevel.DataBindings.Add(new Binding("SelectedValue", users, "Users.UserLevel"));
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
				users.Dispose();
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.tabControl1 = new Crownwood.Magic.Controls.TabControl();
			this.tabPage1 = new Crownwood.Magic.Controls.TabPage();
			this.cboLevel = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.label3 = new System.Windows.Forms.Label();
			this.txtPassword = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.txtUserName = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.cmdOK = new UtilityLibrary.WinControls.ButtonEx();
			this.cmdCancel = new UtilityLibrary.WinControls.ButtonEx();
			this.tabControl1.SuspendLayout();
			this.tabPage1.SuspendLayout();
			this.SuspendLayout();
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					  this.tabPage1});
			this.tabControl1.Dock = System.Windows.Forms.DockStyle.Top;
			this.tabControl1.Font = new System.Drawing.Font("Tahoma", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.World, ((System.Byte)(0)));
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.PositionTop = true;
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.SelectedTab = this.tabPage1;
			this.tabControl1.Size = new System.Drawing.Size(277, 143);
			this.tabControl1.TabIndex = 0;
			this.tabControl1.TabPages.AddRange(new Crownwood.Magic.Controls.TabPage[] {
																						  this.tabPage1});
			// 
			// tabPage1
			// 
			this.tabPage1.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.cboLevel,
																				   this.label3,
																				   this.txtPassword,
																				   this.label2,
																				   this.txtUserName,
																				   this.label1});
			this.tabPage1.Location = new System.Drawing.Point(0, 25);
			this.tabPage1.Name = "tabPage1";
			this.tabPage1.Size = new System.Drawing.Size(277, 118);
			this.tabPage1.TabIndex = 3;
			this.tabPage1.Title = "General";
			// 
			// cboLevel
			// 
			this.cboLevel.AllowUpdates = false;
			this.cboLevel.ComboValue = null;
			this.cboLevel.DataBound = true;
			this.cboLevel.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboLevel.ExtraRefreshes = true;
			this.cboLevel.Location = new System.Drawing.Point(116, 70);
			this.cboLevel.LookupID = "UserLevel";
			this.cboLevel.Name = "cboLevel";
			this.cboLevel.Nullable = false;
			this.cboLevel.Size = new System.Drawing.Size(120, 21);
			this.cboLevel.TabIndex = 11;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(15, 74);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(82, 14);
			this.label3.TabIndex = 10;
			this.label3.Text = "User Level";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// txtPassword
			// 
			this.txtPassword.Location = new System.Drawing.Point(116, 44);
			this.txtPassword.MaxLength = 50;
			this.txtPassword.Name = "txtPassword";
			this.txtPassword.PasswordChar = '*';
			this.txtPassword.Size = new System.Drawing.Size(120, 21);
			this.txtPassword.TabIndex = 9;
			this.txtPassword.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(15, 47);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(82, 14);
			this.label2.TabIndex = 8;
			this.label2.Text = "Password";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// txtUserName
			// 
			this.txtUserName.Location = new System.Drawing.Point(116, 18);
			this.txtUserName.MaxLength = 12;
			this.txtUserName.Name = "txtUserName";
			this.txtUserName.Size = new System.Drawing.Size(120, 21);
			this.txtUserName.TabIndex = 7;
			this.txtUserName.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(15, 20);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(82, 14);
			this.label1.TabIndex = 6;
			this.label1.Text = "User Name";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// cmdOK
			// 
			this.cmdOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.cmdOK.Location = new System.Drawing.Point(141, 150);
			this.cmdOK.Name = "cmdOK";
			this.cmdOK.Size = new System.Drawing.Size(57, 23);
			this.cmdOK.TabIndex = 1;
			this.cmdOK.Text = "OK ";
			this.cmdOK.Click += new System.EventHandler(this.cmdOK_Click);
			// 
			// cmdCancel
			// 
			this.cmdCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdCancel.Location = new System.Drawing.Point(207, 150);
			this.cmdCancel.Name = "cmdCancel";
			this.cmdCancel.Size = new System.Drawing.Size(57, 23);
			this.cmdCancel.TabIndex = 2;
			this.cmdCancel.Text = "Cancel ";
			// 
			// frmUser
			// 
			this.AcceptButton = this.cmdOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cmdCancel;
			this.ClientSize = new System.Drawing.Size(277, 178);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cmdCancel,
																		  this.cmdOK,
																		  this.tabControl1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "frmUser";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "User Details";
			this.tabControl1.ResumeLayout(false);
			this.tabPage1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void cmdOK_Click(object sender, System.EventArgs e)
		{
			this.BindingContext[users,"Users"].EndCurrentEdit();
		}

	}
}
