Attribute VB_Name = "Globals"
Public User As UserSession

Sub Main()

    frmLogin.Show vbModal
    If frmLogin.LoginSucceeded Then
        Unload frmLogin
        If User.IsValid Then
            frmDebtMain.Show
        End If
    Else
        Unload frmLogin
    End If

End Sub

Public Function GetStreet(FullText As Variant) As Variant
    If IsNull(FullText) Then
        GetStreet = Null
        Exit Function
    End If
    Dim z As Long, z2 As Long
    If IsNumeric(Left(FullText, 1)) Then
        z = InStr(1, FullText, " ")
        z2 = InStr(z + 1, FullText, " ")
        If z2 > 0 And z > 0 Then
            GetStreet = Mid(FullText, z + 1, z2 - z - 1) & Left(FullText, z - 1)
        ElseIf z > 0 Then
            GetStreet = Mid(FullText, z + 1) & Left(FullText, z - 1)
        Else
            GetStreet = FullText
        End If
    Else
        GetStreet = FullText
    End If
End Function

Public Function ElimQuotes(thestring As String) As String

    Dim tempstr As String
    Dim Quote As String
    Dim TempStr2 As String
    Dim x As Integer
    
    Quote = "'"
    
    x = InStr(1, thestring, Quote)
    
    Do While x > 0
    
        tempstr = Left(thestring, x)
        TempStr2 = Mid(thestring, x)
        thestring = tempstr & TempStr2
        
        x = InStr(x + 2, thestring, Quote)
        
    Loop
    
    ElimQuotes = thestring

End Function

Public Function StripNewLines(thestring As Variant, Optional ReplaceWith As Variant, Optional PlusSpace) As Variant

    Dim tempstr As String
    Dim Replace As String
    Dim counterA As Long, CounterB As Long
        
    If Not (IsMissing(ReplaceWith) Or IsNull(ReplaceWith)) Then
        Replace = CStr(ReplaceWith)
    Else
        Replace = ","
    End If
    If Not (IsMissing(PlusSpace)) Then
        If PlusSpace Then Replace = Replace & " "
    Else
        Replace = Replace & " "
    End If
    If Not IsNull(thestring) Then
        counterA = 1
        CounterB = InStr(counterA, thestring, Chr(13) & Chr(10))
        If CounterB > 0 Then
            Do While CounterB > 0
                If counterA > 1 Then tempstr = tempstr & Replace
                tempstr = tempstr & Mid(thestring, counterA, CounterB - counterA)
                counterA = CounterB + 2
                CounterB = InStr(counterA, thestring, Chr(13) & Chr(10))
            Loop
            If counterA < Len(thestring) Then
                tempstr = tempstr & Replace & Mid(thestring, counterA)
            End If
        Else
            tempstr = thestring
        End If
        StripNewLines = tempstr
    Else
        StripNewLines = Null
    End If
    Exit Function
SNL_Err:
    StripNewLines = "Error"
    Exit Function
End Function

Public Function nz(Var As Variant, ReplaceWith As Variant) As Variant
    If IsNull(Var) Then
        nz = ReplaceWith
    Else
        nz = Var
    End If
End Function

Sub test()
Dim x As ColumnHeader
    For Each x In frmDebtMain.lvwDiary.ColumnHeaders
        Debug.Print x.Width
    Next
End Sub
