VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTreeViewMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private mDBCon As DBConnection
Private WithEvents mTree As TreeView
Attribute mTree.VB_VarHelpID = -1
Private DragNode As Node

Public Event CaseSelected(PropID As Long)
Public Event StatusBarShow(StatText As String)
Public Event StatusBarFinish()

'Objects and declarations for Scrolling
Private WithEvents scrollTimer As Timer
Attribute scrollTimer.VB_VarHelpID = -1
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
         (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As _
         Integer, ByVal lParam As Long) As Long
Private Const WM_HSCROLL = &H114
Private Const WM_VSCROLL = &H115
Private HScrollDir As Long
Private VScrollDir As Long
Private mfX As Long
Private mfY As Long

Public Property Set TheTimer(tTimer As Timer)
    Set scrollTimer = tTimer
    scrollTimer.Interval = 200
    scrollTimer.Enabled = False
End Property

Public Property Set TheTree(tTree As TreeView)
    Set mTree = tTree
End Property

Public Property Get TheTree() As TreeView
    Set TheTree = mTree
End Property

Public Property Get DBCon() As DBConnection
    Set DBCon = mDBCon
End Property

Public Property Set DBCon(DBConnObj As DBConnection)
    Set mDBCon = DBConnObj
End Property

Public Sub FillTree()
'    mTree.Nodes.Add , tvwRoot, "ROOTNODE", "Clients", 22
'    mTree.Nodes("ROOTNODE").Expanded = True
'    mTree.Nodes.Add "ROOTNODE", tvwChild, "NAME", "Clients By Name", 1
'    mTree.Nodes("NAME").ExpandedImage = 2
'    mTree.Nodes.Add "NAME", tvwChild, "NAMELOADING", "Loading..."
'    mTree.Nodes.Add "ROOTNODE", tvwChild, "ADDR", "Clients By Address", 3
'    mTree.Nodes("ADDR").ExpandedImage = 4
'    mTree.Nodes.Add "ADDR", tvwChild, "ADDRLOADING", "Loading..."
'    mTree.Nodes.Add "ROOTNODE", tvwChild, "ACNO", "Clients By Account Number", 5
'    mTree.Nodes("ACNO").ExpandedImage = 6
'    mTree.Nodes.Add "ACNO", tvwChild, "ACNOLOADING", "Loading..."
'    mTree.Nodes.Add "ROOTNODE", tvwChild, "POST", "Clients By Post Code", 7
'    mTree.Nodes("POST").ExpandedImage = 8
'    mTree.Nodes.Add "POST", tvwChild, "POSTLOADING", "Loading..."
'    mTree.Nodes.Add "ROOTNODE", tvwChild, "POSS", "Clients By Possession Date", 9
'    mTree.Nodes("POSS").ExpandedImage = 10
'    mTree.Nodes.Add "POSS", tvwChild, "POSSLOADING", "Loading..."
'    mTree.Nodes.Add "ROOTNODE", tvwChild, "EDIT", "Clients By Last Edit Date", 11
'    mTree.Nodes("EDIT").ExpandedImage = 12
'    mTree.Nodes.Add "EDIT", tvwChild, "EDITLOADING", "Loading..."
'    mTree.Nodes.Add "ROOTNODE", tvwChild, "USER", "My Favourite Clients", 13
'    mTree.Nodes("USER").ExpandedImage = 14
'    mTree.Nodes.Add "USER", tvwChild, "USERLOADING", "Loading..."
    mTree.Nodes.Add , tvwroot, "ACNO", "Clients By Account Number", 1
    mTree.Nodes("ACNO").ExpandedImage = 2
    mTree.Nodes.Add "ACNO", tvwChild, "ACNOLOADING", "Loading..."
    mTree.Nodes.Add , tvwroot, "ADDR", "Clients By Address", 3
    mTree.Nodes("ADDR").ExpandedImage = 4
    mTree.Nodes.Add "ADDR", tvwChild, "ADDRLOADING", "Loading..."
    mTree.Nodes.Add , tvwroot, "ARRS", "Clients By Degree of Arrears", 5
    mTree.Nodes("ARRS").ExpandedImage = 6
    mTree.Nodes.Add "ARRS", tvwChild, "ARRSLOADING", "Loading..."
    mTree.Nodes.Add , tvwroot, "EDIT", "Clients By Last Edit Date", 7
    mTree.Nodes("EDIT").ExpandedImage = 8
    mTree.Nodes.Add "EDIT", tvwChild, "EDITLOADING", "Loading..."
    mTree.Nodes.Add , tvwroot, "NAME", "Clients By Name", 9
    mTree.Nodes("NAME").ExpandedImage = 10
    mTree.Nodes.Add "NAME", tvwChild, "NAMELOADING", "Loading..."
    mTree.Nodes.Add , tvwroot, "POSS", "Clients By Possession Date", 11
    mTree.Nodes("POSS").ExpandedImage = 12
    mTree.Nodes.Add "POSS", tvwChild, "POSSLOADING", "Loading..."
    mTree.Nodes.Add , tvwroot, "POST", "Clients By Post Code", 1
    mTree.Nodes("POST").ExpandedImage = 2
    mTree.Nodes.Add "POST", tvwChild, "POSTLOADING", "Loading..."
    mTree.Nodes.Add , tvwroot, "USER", "My Favourite Clients", 13
    mTree.Nodes("USER").ExpandedImage = 14
    mTree.Nodes.Add "USER", tvwChild, "USERLOADING", "Loading..."

End Sub

Private Sub Class_Terminate()
    Set mTree = Nothing
    Set DBCon = Nothing
    Set scrollTimer = Nothing
End Sub

Private Sub mTree_Expand(ByVal Node As MSComctlLib.Node)
    ShowSubNodes Node
End Sub

Private Sub mTree_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
   Dim test As Node
   If Button = vbRightButton Then
        Set test = mTree.HitTest(x, y)
        If test Is Nothing Then Exit Sub
        If Len(test.Key) = 4 Then
            mTree.SelectedItem = test
            frmDebtMain.PopupMenu frmDebtMain.mnuTreeCatOptions
        End If
    End If
End Sub

Private Sub mTree_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim test As Node

    If Button = vbLeftButton Then
        Set test = mTree.HitTest(x, y)
        If test Is Nothing Then Exit Sub
        If Left(test.Key, 4) = "PROP" Then
            Set DragNode = test
            mTree.OLEDrag
        End If
    End If
End Sub

Private Sub mTree_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim test As Node
    If Button = vbRightButton Then
        Set test = mTree.HitTest(x, y)
        If test Is Nothing Then Exit Sub
        If Left(test.Key, 4) = "PROP" Then
            If InStr(test.Key, "|USER") Then
                frmDebtMain.PopupMenu frmDebtMain.mnuFavouriteNodes
            Else
                frmDebtMain.PopupMenu frmDebtMain.mnuClientNodes
            End If
        End If
    End If
End Sub

Private Sub mTree_NodeClick(ByVal Node As MSComctlLib.Node)
    Select Case Left(Node.Key, 4)
    Case "PROP"
        RaiseEvent CaseSelected(GetCurrentPropID())
    Case Else
        ShowSubNodes Node
    End Select
End Sub

Private Sub ShowSubNodes(ClickedNode As Node)
    
    Dim rs As ADODB.Recordset, addrcol As Collection, nCounter As Long
    Dim TempVal1, tempkey, CheckVal, FirstCase, fldImage, expImage, TempVal2, TempVal3, Tempval4
    
    RaiseEvent StatusBarShow("Getting Tree Data")
    
    If Len(ClickedNode.Key) = 4 Then
        DoEvents
        If ClickedNode.Tag = "GOT" Then GoTo ssn_end
        Select Case ClickedNode.Key
        Case "USER"
            Set rs = DBCon.OpenReadOnlySQL("Select p.AccountNumber, p.PropID From tblProperties as p inner join tblUserFavourites as f on f.propID = p.PropID where f.UserID = " & User.UserID)
            If Not rs.EOF Then
                While Not rs.EOF
                    mTree.Nodes.Add "USER", tvwChild, "PROP" & rs!PropID & "|USER", rs!AccountNumber, 15
                    rs.MoveNext
                Wend
            End If
            rs.Close
            Set rs = Nothing
            DBCon.ReleaseDB
            mTree.Nodes("USER").Tag = "GOT"
        Case "POSS"
            Set rs = DBCon.OpenReadOnlySQL("Select p.AccountNumber, p.PropID, p.PossessionDate From tblProperties as p Order By p.PossessionDate Desc")
            If Not rs.EOF Then
                FirstCase = True
                fldImage = mTree.Nodes("POSS").Image
                expImage = mTree.Nodes("POSS").ExpandedImage
                While Not rs.EOF
                    If IsNull(rs!PossessionDate) Then
                        If FirstCase Then
                            mTree.Nodes.Add "POSS", tvwChild, "ARRS|POSS", "Arrears Cases", fldImage
                            mTree.Nodes("ARRS|POSS").ExpandedImage = expImage
                            FirstCase = False
                        End If
                        mTree.Nodes.Add "ARRS|POSS", tvwChild, "PROP" & rs!PropID & "|POSS", rs!AccountNumber, 15
                        rs.MoveNext
                    ElseIf TempVal1 = rs!PossessionDate Then
                        mTree.Nodes.Add tempkey, tvwChild, "PROP" & rs!PropID & "|POSS", rs!AccountNumber, 15
                        rs.MoveNext
                    Else
                        TempVal1 = rs!PossessionDate
                        On Error Resume Next
                        tempkey = "DATE" & DatePart("yyyy", TempVal1)
                        mTree.Nodes.Add "POSS", tvwChild, tempkey, DatePart("yyyy", TempVal1), fldImage
                        mTree.Nodes(tempkey).ExpandedImage = expImage
                        tempkey = tempkey & Format(DatePart("m", TempVal1), "00")
                        mTree.Nodes.Add "DATE" & DatePart("yyyy", TempVal1), tvwChild, tempkey, Format(TempVal1, "mmmm"), fldImage
                        mTree.Nodes(tempkey).ExpandedImage = expImage
                        tempkey = tempkey & Format(TempVal1, "dd")
                        mTree.Nodes.Add "DATE" & DatePart("yyyy", TempVal1) & Format(TempVal1, "mm"), tvwChild, tempkey, Format(TempVal1, "dd"), fldImage
                        mTree.Nodes(tempkey).ExpandedImage = expImage
                        On Error GoTo 0
                    End If
                Wend
            End If
            rs.Close
            Set rs = Nothing
            DBCon.ReleaseDB
            mTree.Nodes("POSS").Tag = "GOT"
        Case "POST"
            Set rs = DBCon.OpenReadOnlySQL("Select p.AccountNumber, p.PropID, p.PostCode From tblProperties as p Order By p.Postcode")
            If Not rs.EOF Then
                FirstCase = True
                fldImage = mTree.Nodes("POST").Image
                expImage = mTree.Nodes("POST").ExpandedImage
                While Not rs.EOF
                    If IsNull(rs!PostCode) Then
                        If FirstCase Then
                            mTree.Nodes.Add "POST", tvwChild, "NULL|POST", "No Postcode", fldImage
                            mTree.Nodes("NULL|POST").ExpandedImage = expImage
                            FirstCase = False
                        End If
                        mTree.Nodes.Add "NULL|POST", tvwChild, "PROP" & rs!PropID & "|POST", rs!AccountNumber, 15
                        rs.MoveNext
                    ElseIf TempVal1 = rs!PostCode Then
                        If TempVal2 = TempVal1 Then
                            mTree.Nodes.Add tempkey, tvwChild, "PROP" & rs!PropID & "|POST", rs!AccountNumber, 15
                            rs.MoveNext
                        Else
                            TempVal2 = rs!PostCode
                            tempkey = "POST" & TempVal2
                            mTree.Nodes.Add "POST" & TempVal3, tvwChild, tempkey, Tempval4, fldImage
                            mTree.Nodes(tempkey).ExpandedImage = expImage
                        End If
                    Else
                        TempVal1 = rs!PostCode
                        TempVal3 = Get2PostCodeHalves(TempVal1, Tempval4)
                        mTree.Nodes.Add "POST", tvwChild, "POST" & TempVal3, TempVal3, fldImage
                        mTree.Nodes("POST" & TempVal3).ExpandedImage = expImage
                    End If
                Wend
            End If
            rs.Close
            Set rs = Nothing
            DBCon.ReleaseDB
            mTree.Nodes("POST").Tag = "GOT"
        Case "ACNO"
            Set rs = DBCon.OpenReadOnlySQL("Select p.AccountNumber, p.PropID From tblProperties as p Order By p.accountnumber")
            If Not rs.EOF Then
                FirstCase = True
                fldImage = mTree.Nodes("ACNO").Image
                expImage = mTree.Nodes("ACNO").ExpandedImage
                While Not rs.EOF
                    mTree.Nodes.Add "ACNO", tvwChild, "PROP" & rs!PropID & "|ACNO", rs!AccountNumber, 15
                    rs.MoveNext
                Wend
            End If
            rs.Close
            Set rs = Nothing
            DBCon.ReleaseDB
            mTree.Nodes("ACNO").Tag = "GOT"
        Case "ADDR"
            Set rs = DBCon.OpenReadOnlySQL("Select p.AccountNumber, p.PropID, p.PropertyAddress From tblProperties as p")
            If Not rs.EOF Then
                fldImage = mTree.Nodes("ADDR").Image
                expImage = mTree.Nodes("ADDR").ExpandedImage
                While Not rs.EOF
                    Set addrcol = GetAddressChunks(rs!PropertyAddress)
                    If addrcol.Count > 0 Then
                        If addrcol.Count > 1 Then
                            On Error Resume Next
                            tempkey = "ADDR" & addrcol(addrcol.Count)
                            mTree.Nodes.Add "ADDR", tvwChild, "ADDR" & addrcol(addrcol.Count), addrcol(addrcol.Count), fldImage
                            mTree.Nodes(tempkey).ExpandedImage = expImage
                            If addrcol.Count > 2 Then
                                For nCounter = addrcol.Count - 1 To 2 Step -1
                                    tempkey = "ADDR" & addrcol(nCounter)
                                    mTree.Nodes.Add "ADDR" & addrcol(nCounter + 1), tvwChild, tempkey, addrcol(nCounter), fldImage
                                    mTree.Nodes(tempkey).ExpandedImage = expImage
                                Next
                            End If
                            On Error GoTo 0
                            mTree.Nodes.Add tempkey, tvwChild, "PROP" & rs!PropID & "|ADDR", addrcol(1) & ": " & rs!AccountNumber, 15
                        Else
                            mTree.Nodes.Add "ADDR", tvwChild, "PROP" & rs!PropID & "|ADDR", addrcol(1) & ": " & rs!AccountNumber, 15
                        End If
                    Else
                        mTree.Nodes.Add "ADDR", tvwChild, "PROP" & rs!PropID & "|ADDR", rs!AccountNumber, 15
                    End If
                    rs.MoveNext
                Wend
            End If
            rs.Close
            Set rs = Nothing
            DBCon.ReleaseDB
            mTree.Nodes("ADDR").Tag = "GOT"
        Case "ARRS"
            Set rs = DBCon.OpenReadOnlySQL("Select p.AccountNumber, p.PropID, p.ArrearsDegree From tblProperties as p Order By p.ArrearsDegree")
            If Not rs.EOF Then
                FirstCase = True
                fldImage = mTree.Nodes("ARRS").Image
                expImage = mTree.Nodes("ARRS").ExpandedImage
                While Not rs.EOF
                    If IsNull(rs!ArrearsDegree) Then
                        If FirstCase Then
                            mTree.Nodes.Add "ARRS", tvwChild, "NULL|ARRS", "No Degree Set", fldImage
                            mTree.Nodes("NULL|ARRS").ExpandedImage = expImage
                            FirstCase = False
                        End If
                        mTree.Nodes.Add "NULL|ARRS", tvwChild, "PROP" & rs!PropID & "|ARRS", rs!AccountNumber, 15
                        rs.MoveNext
                    ElseIf TempVal1 = rs!ArrearsDegree Then
                        mTree.Nodes.Add tempkey, tvwChild, "PROP" & rs!PropID & "|ARRS", rs!AccountNumber, 15
                        rs.MoveNext
                    Else
                        TempVal1 = rs!ArrearsDegree
                        tempkey = "ARRS" & TempVal1
                        mTree.Nodes.Add "ARRS", tvwChild, tempkey, TempVal1, fldImage
                        mTree.Nodes(tempkey).ExpandedImage = expImage
                    End If
                Wend
            End If
            rs.Close
            Set rs = Nothing
            DBCon.ReleaseDB
            mTree.Nodes("ARRS").Tag = "GOT"
        Case "NAME"
            Set rs = DBCon.OpenReadOnlySQL("Select p.AccountNumber, p.PropID, c.custID, c.Surname, c.title,c.initials From tblProperties as p left join tblcustomers as c on c.propId = p.propID Order By c.surname, c.initials")
            If Not rs.EOF Then
                FirstCase = True
                fldImage = mTree.Nodes("NAME").Image
                expImage = mTree.Nodes("NAME").ExpandedImage
                While Not rs.EOF
                    If IsNull(rs!surname) Then
                        If FirstCase Then
                            mTree.Nodes.Add "NAME", tvwChild, "NULL|NAME", "No Customer", fldImage
                            mTree.Nodes("NULL|NAME").ExpandedImage = expImage
                            FirstCase = False
                        End If
                        mTree.Nodes.Add "NULL|NAME", tvwChild, "PROP" & rs!PropID & "|NAME", rs!AccountNumber, 15
                        rs.MoveNext
                    ElseIf TempVal1 = Left(rs!surname, 1) Then
                        If TempVal2 = rs!surname Then
                            mTree.Nodes.Add tempkey, tvwChild, "PROP" & rs!PropID & "|NAME|CUST" & rs!custID, rs!Title & " " & rs!initials & ": " & rs!AccountNumber, 15
                            rs.MoveNext
                        Else
                            TempVal2 = rs!surname
                            tempkey = "NAME" & TempVal2
                            mTree.Nodes.Add "NAME" & TempVal1, tvwChild, tempkey, TempVal2, fldImage
                            mTree.Nodes(tempkey).ExpandedImage = expImage
                        End If
                    Else
                        TempVal1 = Left(rs!surname, 1)
                        mTree.Nodes.Add "NAME", tvwChild, "NAME" & TempVal1, UCase(TempVal1), fldImage
                        mTree.Nodes("NAME" & TempVal1).ExpandedImage = expImage
                    End If
                Wend
            End If
            rs.Close
            Set rs = Nothing
            DBCon.ReleaseDB
            mTree.Nodes("NAME").Tag = "GOT"
        Case "EDIT"
            Set rs = DBCon.OpenReadOnlySQL("Select p.AccountNumber, p.PropID, p.LastUpdated From tblProperties as p Order By p.LastUpdated Desc")
            If Not rs.EOF Then
                FirstCase = True
                fldImage = mTree.Nodes("EDIT").Image
                expImage = mTree.Nodes("EDIT").ExpandedImage
                While Not rs.EOF
                    If IsNull(rs!LastUpdated) Then
                        If FirstCase Then
                            mTree.Nodes.Add "EDIT", tvwChild, "NULL|EDIT", "No Edit Date", fldImage
                            mTree.Nodes("NULL|EDIT").ExpandedImage = expImage
                            FirstCase = False
                        End If
                        mTree.Nodes.Add "NULL|EDIT", tvwChild, "PROP" & rs!PropID & "|EDIT", rs!AccountNumber, 15
                        rs.MoveNext
                    ElseIf TempVal1 = rs!LastUpdated Then
                        mTree.Nodes.Add tempkey, tvwChild, "PROP" & rs!PropID & "|EDIT", rs!AccountNumber, 15
                        rs.MoveNext
                    Else
                        TempVal1 = rs!LastUpdated
                        On Error Resume Next
                        tempkey = "DATE" & DatePart("yyyy", TempVal1)
                        mTree.Nodes.Add "EDIT", tvwChild, tempkey & "|EDIT", DatePart("yyyy", TempVal1), fldImage
                        mTree.Nodes(tempkey & "|EDIT").ExpandedImage = expImage
                        tempkey = tempkey & Format(DatePart("m", TempVal1), "00")
                        mTree.Nodes.Add "DATE" & DatePart("yyyy", TempVal1) & "|EDIT", tvwChild, tempkey & "|EDIT", Format(TempVal1, "mmmm"), fldImage
                        mTree.Nodes(tempkey & "|EDIT").ExpandedImage = expImage
                        tempkey = tempkey & Format(TempVal1, "dd") & "|EDIT"
                        mTree.Nodes.Add "DATE" & DatePart("yyyy", TempVal1) & Format(TempVal1, "mm") & "|EDIT", tvwChild, tempkey, Format(TempVal1, "dd"), fldImage
                        mTree.Nodes(tempkey).ExpandedImage = expImage
                        On Error GoTo 0
                    End If
                Wend
            End If
            rs.Close
            Set rs = Nothing
            DBCon.ReleaseDB
            mTree.Nodes("EDIT").Tag = "GOT"
        End Select
        On Error Resume Next
        mTree.Nodes.Remove ClickedNode.Key & "LOADING"
        On Error GoTo 0
    End If
ssn_end:
    RaiseEvent StatusBarFinish
    
End Sub

Private Sub mTree_OLECompleteDrag(Effect As Long)
    Set DragNode = Nothing
    mTree.DropHighlight = Nothing
    If Not scrollTimer Is Nothing Then
        scrollTimer.Enabled = False
        hscrolltimer = 0: vscrolltimer = 0
    End If
End Sub

Private Sub mTree_OLEDragDrop(Data As MSComctlLib.DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)
    If Effect <> vbDropEffectNone Then
        If DragNode.Key = Data.GetData(vbCFText) Then
            Dim tempLong As Long, tempstr As String
            tempLong = InStr(DragNode.Key, "|")
            If tempLong > 0 Then
                tempstr = Left(DragNode.Key, tempLong - 1)
                tempLong = CLng(Mid(tempstr, 5))
            Else
                tempLong = CLng(Mid(DragNode.Key, 5))
            End If
            AddToFavourites tempLong
        End If
    End If
End Sub

Private Sub mTree_OLEDragOver(Data As MSComctlLib.DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single, State As Integer)
    Dim test As Node
    Static lastScroll As Date
    Dim lines As Long
    Set test = mTree.HitTest(x, y)
    mfX = x: mfY = y
    DoDropHighlight test, Effect ' Effect is updated by subroutine
    If Not scrollTimer Is Nothing Then
        If y > 100 And y < 350 Then
            VScrollDir = -1
        ElseIf y > (mTree.Height - 350) And y < (mTree.Height - 100) Then
            VScrollDir = 1
        Else
            VScrollDir = 0
        End If
        If x > 100 And x < 350 Then
            HScrollDir = -1
        ElseIf x > (mTree.Width - 350) And x < (mTree.Width - 100) Then
            HScrollDir = 1
        Else
            HScrollDir = 0
        End If
        If HScrollDir <> 0 Or VScrollDir <> 0 Then
            scrollTimer.Enabled = True
        Else
            scrollTimer.Enabled = False
        End If
    End If
End Sub

Private Sub mTree_OLEStartDrag(Data As MSComctlLib.DataObject, AllowedEffects As Long)
    AllowedEffects = vbDropEffectCopy
    Data.Clear
    Data.SetData DragNode.Key, vbCFText
    mTree.SelectedItem = DragNode
    Call mTree_NodeClick(DragNode)
End Sub

Private Sub scrollTimer_Timer()
    DoDropHighlight mTree.HitTest(mfX, mfY), 0
    If HScrollDir <> 0 Then
        If HScrollDir < 0 Then
            SendMessage mTree.hwnd, WM_HSCROLL, 0&, vbNull
        Else
            SendMessage mTree.hwnd, WM_HSCROLL, 1&, vbNull
        End If
    End If
    If VScrollDir <> 0 Then
        If VScrollDir < 0 Then
            SendMessage mTree.hwnd, WM_VSCROLL, 0&, vbNull
        Else
            SendMessage mTree.hwnd, WM_VSCROLL, 1&, vbNull
        End If
    End If
End Sub

Private Sub DoDropHighlight(theNode As Node, ByRef Effect As Long)
    If theNode Is Nothing Or DragNode Is Nothing Then
        Effect = vbDropEffectNone
        mTree.DropHighlight = Nothing
    Else
        If Left(theNode.Key, 4) = "USER" Then
            Effect = vbDropEffectCopy
            mTree.DropHighlight = theNode
        Else
            Effect = vbDropEffectNone
            mTree.DropHighlight = Nothing
        End If
    End If
End Sub

Public Function GetCurrentPropID() As Long
    Dim tempLong As Long, tempstr As String
    
    tempstr = mTree.SelectedItem.Key
    If Left(tempstr, 4) <> "PROP" Then
        GetCurrentPropID = 0
    Else
        tempLong = InStr(tempstr, "|")
        If tempLong > 0 Then
            tempstr = Left(tempstr, tempLong - 1)
        End If
        GetCurrentPropID = Mid(tempstr, 5)
    End If
End Function

Public Function AddToFavourites(PropID As Long) As Boolean

    Dim rs As ADODB.Recordset

    If PropID > 0 Then
        Set rs = DBCon.OpenReadOnlySQL("Select FavID from tblUserfavourites where UserID = " & User.UserID & " And PropID = " & PropID)
        If rs.EOF Then
            DBCon.DB.Execute "Insert into tblUserFavourites (UserID,PropID,DateAdded) Values (" & User.UserID & "," & PropID & ",#" & Format(Date, "mm/dd/yyyy") & "#)"
            AddToFavourites = True
        End If
        rs.Close
        Set rs = Nothing
        DBCon.ReleaseDB
        If AddToFavourites Then RefreshCategory "USER"
    End If

End Function

Public Function RemoveFromFavourites(PropID As Long) As Boolean

    If PropID > 0 Then
        DBCon.DB.Execute "Delete from tblUserFavourites where UserID = " & User.UserID & " AND PropID = " & PropID
        RemoveFromFavourites = True
        DBCon.ReleaseDB
        If RemoveFromFavourites Then RefreshCategory "USER"
    End If

End Function

Public Sub RefreshCategory(MasterKey As String)
    
    While mTree.Nodes(MasterKey).Children > 0
        mTree.Nodes.Remove mTree.Nodes(MasterKey).Child.Key
    Wend
    mTree.Nodes(MasterKey).Tag = ""
    ShowSubNodes mTree.Nodes(MasterKey)
    
End Sub

Public Sub ShowItem(PropID As Long)

    Dim x As Node, found As Boolean
    Dim temp As String, tempLong As Long
    
    temp = "PROP" & PropID
    tempLong = Len(temp)
    
    For Each x In mTree.Nodes
        If Left(x.Key, tempLong) = temp Then
            x.EnsureVisible
            x.Selected = True
            found = True
            Exit For
        End If
    Next
    
    If Not found Then
        ShowSubNodes mTree.Nodes("ACNO")
        For Each x In mTree.Nodes
            If Left(x.Key, tempLong) = temp Then
                x.EnsureVisible
                x.Selected = True
                found = True
                Exit For
            End If
        Next
    End If
    
    If Not found Then MsgBox "Couldn't locate selected case in the tree."

End Sub

Public Function Get2PostCodeHalves(thePostcode, ByRef SecondHalf)
    Dim x As Long
    
    x = InStr(thePostcode, " ")
    If Not x > 0 Then
        Get2PostCodeHalves = thePostcode
        SecondHalf = ""
    Else
        Get2PostCodeHalves = Left(thePostcode, x - 1)
        SecondHalf = Mid(thePostcode, x + 1)
    End If
End Function

Public Function GetAddressChunks(thestring As Variant) As Collection
On Error GoTo SNL_Err
    Dim tempstr As String
    Dim Replace As String
    Dim counterA As Long, CounterB As Long
    Dim z As Long, z2 As Long
    
    Set GetAddressChunks = New Collection
        
    If IsNull(thestring) Then
        Exit Function
    End If
    
    If IsNumeric(Left(thestring, 1)) Then
        z = InStr(1, thestring, " ")
        If z > 0 Then
            GetAddressChunks.Add Left(thestring, z - 1)
        End If
    End If
        
    If z > 0 Then
        counterA = z + 1
    Else
        counterA = 1
    End If
    CounterB = InStr(counterA, thestring, Chr(13) & Chr(10))
    If CounterB > 0 Then
        Do While CounterB > 0
            GetAddressChunks.Add Mid(thestring, counterA, CounterB - counterA)
            counterA = CounterB + 2
            CounterB = InStr(counterA, thestring, Chr(13) & Chr(10))
        Loop
        If counterA < Len(thestring) Then
            GetAddressChunks.Add Mid(thestring, counterA)
        End If
    Else
        If counterA > 1 Then
            GetAddressChunks.Add Mid(thestring, counterA)
        Else
            GetAddressChunks.Add thestring
        End If
    End If
    
    Exit Function
SNL_Err:
    GetAddressChunks.Add "Error"
    Exit Function
End Function
