using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.OleDb;
using System.Diagnostics;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class TestForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListBox lstTest;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.Button button5;
		private System.Windows.Forms.Button button6;
		private System.ComponentModel.IContainer components;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboBranch;
		private Crownwood.Magic.Menus.MenuControl menuControl1;
		private Crownwood.Magic.Menus.MenuCommand menuCommand1;
		private Crownwood.Magic.Controls.TabControl tabControl1;
		private Crownwood.Magic.Controls.TabPage tabPage1;
		private Crownwood.Magic.Controls.TabPage tabPage2;
		private Crownwood.Magic.Controls.TabPage tabPage3;
		private DebtManagerTest.LookupComboObjects.LookupCombo lookupCombo1;
		private Crownwood.Magic.Menus.MenuCommand menuCommand2;
		private Crownwood.Magic.Menus.MenuCommand menuCommand3;
		private Crownwood.Magic.Menus.MenuCommand menuCommand4;
		private UtilityLibrary.CommandBars.ReBar reBar1;
		private UtilityLibrary.CommandBars.ToolBarEx toolBarEx1;
		private UtilityLibrary.WinControls.OutlookBar outlookBar1;
		private DebtManagerTest.InterfaceComponents.CaseTreeViewEx tvwCases;
		private DebtManagerTest.InterfaceComponents.DiaryListView diaryListView1;
		private System.Data.OleDb.OleDbDataAdapter oleDbDataAdapter1;
		private System.Data.OleDb.OleDbCommand oleDbSelectCommand1;
		private System.Data.OleDb.OleDbCommand oleDbInsertCommand1;
		private System.Data.OleDb.OleDbCommand oleDbUpdateCommand1;
		private System.Data.OleDb.OleDbCommand oleDbDeleteCommand1;
		private System.Data.OleDb.OleDbConnection oleDbConnection1;
		private DebtManagerTest.InterfaceComponents.FindCase findCase1;
		private DebtManagerTest.DataSet1 dataSet11;
		private System.Windows.Forms.Button button7;
		private System.Windows.Forms.Button button8;
		private System.Windows.Forms.Button button9;
		private UtilityLibrary.WinControls.TextBoxEx textBoxEx1;
		private System.Windows.Forms.Button button10;
		private System.Windows.Forms.DateTimePicker dtp1;
		private System.Windows.Forms.DateTimePicker dtp2;
		private object mComboValue = null;

		public object ComboValue
		{
			get 
			{
				return mComboValue;
			}
			set
			{
				mComboValue = value;
			}
		}

		public TestForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			tvwCases.FillDefaultDebtTree();
			diaryListView1.GetData();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
				LookupDataManager.CleanUp();
				cMyDB.CleanUp();
				CSession.CleanUp();
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lstTest = new System.Windows.Forms.ListBox();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.button3 = new System.Windows.Forms.Button();
			this.button4 = new System.Windows.Forms.Button();
			this.button5 = new System.Windows.Forms.Button();
			this.button6 = new System.Windows.Forms.Button();
			this.cboBranch = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.menuControl1 = new Crownwood.Magic.Menus.MenuControl();
			this.menuCommand1 = new Crownwood.Magic.Menus.MenuCommand();
			this.menuCommand2 = new Crownwood.Magic.Menus.MenuCommand();
			this.menuCommand3 = new Crownwood.Magic.Menus.MenuCommand();
			this.menuCommand4 = new Crownwood.Magic.Menus.MenuCommand();
			this.tabControl1 = new Crownwood.Magic.Controls.TabControl();
			this.tabPage1 = new Crownwood.Magic.Controls.TabPage();
			this.diaryListView1 = new DebtManagerTest.InterfaceComponents.DiaryListView();
			this.tabPage2 = new Crownwood.Magic.Controls.TabPage();
			this.tabPage3 = new Crownwood.Magic.Controls.TabPage();
			this.findCase1 = new DebtManagerTest.InterfaceComponents.FindCase();
			this.lookupCombo1 = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.button9 = new System.Windows.Forms.Button();
			this.button8 = new System.Windows.Forms.Button();
			this.button7 = new System.Windows.Forms.Button();
			this.dataSet11 = new DebtManagerTest.DataSet1();
			this.reBar1 = new UtilityLibrary.CommandBars.ReBar();
			this.toolBarEx1 = new UtilityLibrary.CommandBars.ToolBarEx();
			this.outlookBar1 = new UtilityLibrary.WinControls.OutlookBar();
			this.tvwCases = new DebtManagerTest.InterfaceComponents.CaseTreeViewEx();
			this.oleDbDataAdapter1 = new System.Data.OleDb.OleDbDataAdapter();
			this.oleDbDeleteCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbConnection1 = new System.Data.OleDb.OleDbConnection();
			this.oleDbInsertCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbUpdateCommand1 = new System.Data.OleDb.OleDbCommand();
			this.textBoxEx1 = new UtilityLibrary.WinControls.TextBoxEx();
			this.button10 = new System.Windows.Forms.Button();
			this.dtp1 = new System.Windows.Forms.DateTimePicker();
			this.dtp2 = new System.Windows.Forms.DateTimePicker();
			this.tabControl1.SuspendLayout();
			this.tabPage1.SuspendLayout();
			this.tabPage3.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dataSet11)).BeginInit();
			this.SuspendLayout();
			// 
			// lstTest
			// 
			this.lstTest.Location = new System.Drawing.Point(341, 43);
			this.lstTest.Name = "lstTest";
			this.lstTest.Size = new System.Drawing.Size(153, 108);
			this.lstTest.TabIndex = 0;
			this.lstTest.SelectedValueChanged += new System.EventHandler(this.lstTest_SelectedValueChanged);
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(599, 43);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(69, 32);
			this.button1.TabIndex = 1;
			this.button1.Text = "button1";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(599, 82);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(69, 32);
			this.button2.TabIndex = 2;
			this.button2.Text = "button2";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// button3
			// 
			this.button3.Location = new System.Drawing.Point(510, 44);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(69, 32);
			this.button3.TabIndex = 3;
			this.button3.Text = "button3";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// button4
			// 
			this.button4.Location = new System.Drawing.Point(511, 82);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(69, 32);
			this.button4.TabIndex = 4;
			this.button4.Text = "button4";
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// button5
			// 
			this.button5.Location = new System.Drawing.Point(511, 118);
			this.button5.Name = "button5";
			this.button5.Size = new System.Drawing.Size(69, 32);
			this.button5.TabIndex = 5;
			this.button5.Text = "button5";
			this.button5.Click += new System.EventHandler(this.button5_Click);
			// 
			// button6
			// 
			this.button6.Location = new System.Drawing.Point(596, 121);
			this.button6.Name = "button6";
			this.button6.Size = new System.Drawing.Size(66, 26);
			this.button6.TabIndex = 6;
			this.button6.Text = "button6";
			this.button6.Click += new System.EventHandler(this.button6_Click);
			// 
			// cboBranch
			// 
			this.cboBranch.AllowUpdates = true;
			this.cboBranch.ComboValue = null;
			this.cboBranch.DataBound = true;
			this.cboBranch.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboBranch.ExtraRefreshes = true;
			this.cboBranch.Location = new System.Drawing.Point(343, 160);
			this.cboBranch.LookupID = "Branch";
			this.cboBranch.Name = "cboBranch";
			this.cboBranch.Size = new System.Drawing.Size(323, 21);
			this.cboBranch.TabIndex = 7;
			// 
			// menuControl1
			// 
			this.menuControl1.BackColor = System.Drawing.SystemColors.Control;
			this.menuControl1.Direction = Crownwood.Magic.Common.Direction.Horizontal;
			this.menuControl1.Dock = System.Windows.Forms.DockStyle.Top;
			this.menuControl1.Font = new System.Drawing.Font("Tahoma", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.World, ((System.Byte)(0)));
			this.menuControl1.Location = new System.Drawing.Point(86, 0);
			this.menuControl1.MenuCommands.AddRange(new Crownwood.Magic.Menus.MenuCommand[] {
																								this.menuCommand1});
			this.menuControl1.Name = "menuControl1";
			this.menuControl1.Size = new System.Drawing.Size(625, 25);
			this.menuControl1.Style = Crownwood.Magic.Common.VisualStyle.IDE;
			this.menuControl1.TabIndex = 8;
			this.menuControl1.TabStop = false;
			this.menuControl1.Text = "menuControl1";
			this.menuControl1.PopupStart += new Crownwood.Magic.Menus.CommandHandler(this.menuControl1_PopupStart);
			// 
			// menuCommand1
			// 
			this.menuCommand1.Description = "MenuItem";
			this.menuCommand1.MenuCommands.AddRange(new Crownwood.Magic.Menus.MenuCommand[] {
																								this.menuCommand2,
																								this.menuCommand3,
																								this.menuCommand4});
			// 
			// menuCommand2
			// 
			this.menuCommand2.Description = "MenuItem";
			// 
			// menuCommand3
			// 
			this.menuCommand3.Description = "MenuItem";
			// 
			// menuCommand4
			// 
			this.menuCommand4.Description = "MenuItem";
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					  this.tabPage1,
																					  this.tabPage2,
																					  this.tabPage3});
			this.tabControl1.Font = new System.Drawing.Font("Tahoma", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.World, ((System.Byte)(0)));
			this.tabControl1.Location = new System.Drawing.Point(342, 198);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.PositionTop = true;
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.SelectedTab = this.tabPage1;
			this.tabControl1.ShowArrows = true;
			this.tabControl1.Size = new System.Drawing.Size(343, 169);
			this.tabControl1.TabIndex = 9;
			this.tabControl1.TabPages.AddRange(new Crownwood.Magic.Controls.TabPage[] {
																						  this.tabPage1,
																						  this.tabPage2,
																						  this.tabPage3});
			// 
			// tabPage1
			// 
			this.tabPage1.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.diaryListView1});
			this.tabPage1.Location = new System.Drawing.Point(0, 25);
			this.tabPage1.Name = "tabPage1";
			this.tabPage1.Size = new System.Drawing.Size(343, 144);
			this.tabPage1.TabIndex = 3;
			// 
			// diaryListView1
			// 
			this.diaryListView1.AllowDrop = true;
			this.diaryListView1.FullRowSelect = true;
			this.diaryListView1.HeaderImageList = null;
			this.diaryListView1.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.diaryListView1.Location = new System.Drawing.Point(9, 6);
			this.diaryListView1.Name = "diaryListView1";
			this.diaryListView1.PendingEntriesOnly = true;
			this.diaryListView1.Size = new System.Drawing.Size(327, 131);
			this.diaryListView1.Sorting = System.Windows.Forms.SortOrder.Descending;
			this.diaryListView1.TabIndex = 0;
			this.diaryListView1.View = System.Windows.Forms.View.Details;
			this.diaryListView1.SelectedIndexChanged += new System.EventHandler(this.diaryListView1_SelectedIndexChanged);
			// 
			// tabPage2
			// 
			this.tabPage2.Location = new System.Drawing.Point(0, 25);
			this.tabPage2.Name = "tabPage2";
			this.tabPage2.Selected = false;
			this.tabPage2.Size = new System.Drawing.Size(343, 144);
			this.tabPage2.TabIndex = 4;
			// 
			// tabPage3
			// 
			this.tabPage3.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.findCase1,
																				   this.lookupCombo1});
			this.tabPage3.Location = new System.Drawing.Point(0, 25);
			this.tabPage3.Name = "tabPage3";
			this.tabPage3.Selected = false;
			this.tabPage3.Size = new System.Drawing.Size(343, 144);
			this.tabPage3.TabIndex = 5;
			// 
			// findCase1
			// 
			this.findCase1.Location = new System.Drawing.Point(13, 7);
			this.findCase1.Name = "findCase1";
			this.findCase1.Size = new System.Drawing.Size(226, 127);
			this.findCase1.TabIndex = 1;
			// 
			// lookupCombo1
			// 
			this.lookupCombo1.AllowUpdates = true;
			this.lookupCombo1.ComboValue = null;
			this.lookupCombo1.DataBound = true;
			this.lookupCombo1.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.lookupCombo1.ExtraRefreshes = true;
			this.lookupCombo1.Location = new System.Drawing.Point(258, 13);
			this.lookupCombo1.LookupID = "HoldCode";
			this.lookupCombo1.Name = "lookupCombo1";
			this.lookupCombo1.Size = new System.Drawing.Size(69, 21);
			this.lookupCombo1.TabIndex = 0;
			// 
			// button9
			// 
			this.button9.Location = new System.Drawing.Point(342, 454);
			this.button9.Name = "button9";
			this.button9.TabIndex = 4;
			this.button9.Text = "NextRecord";
			this.button9.Click += new System.EventHandler(this.button9_Click);
			// 
			// button8
			// 
			this.button8.Location = new System.Drawing.Point(344, 420);
			this.button8.Name = "button8";
			this.button8.Size = new System.Drawing.Size(55, 23);
			this.button8.TabIndex = 3;
			this.button8.Text = "Update";
			this.button8.Click += new System.EventHandler(this.button8_Click);
			// 
			// button7
			// 
			this.button7.Location = new System.Drawing.Point(345, 382);
			this.button7.Name = "button7";
			this.button7.Size = new System.Drawing.Size(51, 23);
			this.button7.TabIndex = 2;
			this.button7.Text = "Get";
			this.button7.Click += new System.EventHandler(this.button7_Click);
			// 
			// dataSet11
			// 
			this.dataSet11.DataSetName = "DataSet1";
			this.dataSet11.Locale = new System.Globalization.CultureInfo("en-GB");
			this.dataSet11.Namespace = "http://www.tempuri.org/DataSet1.xsd";
			// 
			// reBar1
			// 
			this.reBar1.Dock = System.Windows.Forms.DockStyle.Top;
			this.reBar1.Name = "reBar1";
			this.reBar1.Size = new System.Drawing.Size(711, 0);
			this.reBar1.TabIndex = 17;
			this.reBar1.TabStop = false;
			this.reBar1.Text = "reBar1";
			// 
			// toolBarEx1
			// 
			this.toolBarEx1.Dock = System.Windows.Forms.DockStyle.Top;
			this.toolBarEx1.Name = "toolBarEx1";
			this.toolBarEx1.Size = new System.Drawing.Size(711, 0);
			this.toolBarEx1.TabIndex = 19;
			this.toolBarEx1.TabStop = false;
			this.toolBarEx1.Text = "toolBarEx1";
			// 
			// outlookBar1
			// 
			this.outlookBar1.AnimationSpeed = 20;
			this.outlookBar1.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.outlookBar1.Dock = System.Windows.Forms.DockStyle.Left;
			this.outlookBar1.Font = new System.Drawing.Font("Tahoma", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.World, ((System.Byte)(0)));
			this.outlookBar1.Name = "outlookBar1";
			this.outlookBar1.Size = new System.Drawing.Size(86, 487);
			this.outlookBar1.TabIndex = 24;
			this.outlookBar1.Text = "outlookBar1";
			// 
			// tvwCases
			// 
			this.tvwCases.AllowDrop = true;
			this.tvwCases.HideSelection = false;
			this.tvwCases.Indent = 19;
			this.tvwCases.Location = new System.Drawing.Point(103, 43);
			this.tvwCases.Name = "tvwCases";
			this.tvwCases.ShowRootLines = false;
			this.tvwCases.Size = new System.Drawing.Size(209, 334);
			this.tvwCases.TabIndex = 25;
			// 
			// oleDbDataAdapter1
			// 
			this.oleDbDataAdapter1.DeleteCommand = this.oleDbDeleteCommand1;
			this.oleDbDataAdapter1.InsertCommand = this.oleDbInsertCommand1;
			this.oleDbDataAdapter1.SelectCommand = this.oleDbSelectCommand1;
			this.oleDbDataAdapter1.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																										new System.Data.Common.DataTableMapping("Table", "Diary", new System.Data.Common.DataColumnMapping[] {
																																																				 new System.Data.Common.DataColumnMapping("ID", "ID"),
																																																				 new System.Data.Common.DataColumnMapping("CaseID", "CaseID"),
																																																				 new System.Data.Common.DataColumnMapping("UserID", "UserID"),
																																																				 new System.Data.Common.DataColumnMapping("ActionType", "ActionType"),
																																																				 new System.Data.Common.DataColumnMapping("Description", "Description"),
																																																				 new System.Data.Common.DataColumnMapping("ActionDate", "ActionDate"),
																																																				 new System.Data.Common.DataColumnMapping("Completed", "Completed"),
																																																				 new System.Data.Common.DataColumnMapping("DateActioned", "DateActioned"),
																																																				 new System.Data.Common.DataColumnMapping("Created", "Created"),
																																																				 new System.Data.Common.DataColumnMapping("CreateUser", "CreateUser"),
																																																				 new System.Data.Common.DataColumnMapping("LastUpdated", "LastUpdated"),
																																																				 new System.Data.Common.DataColumnMapping("LastUser", "LastUser"),
																																																				 new System.Data.Common.DataColumnMapping("Notes", "Notes")})});
			this.oleDbDataAdapter1.UpdateCommand = this.oleDbUpdateCommand1;
			// 
			// oleDbDeleteCommand1
			// 
			this.oleDbDeleteCommand1.CommandText = @"DELETE FROM Diary WHERE (ID = ?) AND (ActionDate = ? OR ? IS NULL AND ActionDate IS NULL) AND (Completed = ?) AND (CreateUser = ? OR ? IS NULL AND CreateUser IS NULL) AND (Created = ? OR ? IS NULL AND Created IS NULL) AND (DateActioned = ? OR ? IS NULL AND DateActioned IS NULL) AND (Description = ? OR ? IS NULL AND Description IS NULL) AND (LastUpdated = ? OR ? IS NULL AND LastUpdated IS NULL) AND (LastUser = ? OR ? IS NULL AND LastUser IS NULL) AND (Notes = ? OR ? IS NULL AND Notes IS NULL)";
			this.oleDbDeleteCommand1.Connection = this.oleDbConnection1;
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_ActionDate", System.Data.OleDb.OleDbType.DBDate, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ActionDate", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_ActionDate1", System.Data.OleDb.OleDbType.DBDate, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ActionDate", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_Completed", System.Data.OleDb.OleDbType.Boolean, 2, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Completed", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_CreateUser", System.Data.OleDb.OleDbType.VarWChar, 12, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CreateUser", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_CreateUser1", System.Data.OleDb.OleDbType.VarWChar, 12, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CreateUser", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_Created", System.Data.OleDb.OleDbType.DBDate, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Created", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_Created1", System.Data.OleDb.OleDbType.DBDate, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Created", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_DateActioned", System.Data.OleDb.OleDbType.DBDate, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "DateActioned", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_DateActioned1", System.Data.OleDb.OleDbType.DBDate, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "DateActioned", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_Description", System.Data.OleDb.OleDbType.VarWChar, 255, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Description", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_Description1", System.Data.OleDb.OleDbType.VarWChar, 255, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Description", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUpdated", System.Data.OleDb.OleDbType.DBDate, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUpdated1", System.Data.OleDb.OleDbType.DBDate, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUser", System.Data.OleDb.OleDbType.VarWChar, 12, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUser", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUser1", System.Data.OleDb.OleDbType.VarWChar, 12, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUser", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_Notes", System.Data.OleDb.OleDbType.VarWChar, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Notes", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_Notes1", System.Data.OleDb.OleDbType.VarWChar, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Notes", System.Data.DataRowVersion.Original, null));
			// 
			// oleDbConnection1
			// 
			this.oleDbConnection1.ConnectionString = @"Provider=Microsoft.Jet.OLEDB.4.0;Password="""";User ID=Admin;Data Source=D:\Documents and Settings\Gavin Bowman\My Documents\debt2000NET.mdb;Mode=Share Deny None;Extended Properties="""";Jet OLEDB:System database="""";Jet OLEDB:Registry Path="""";Jet OLEDB:Database Password="""";Jet OLEDB:Engine Type=5;Jet OLEDB:Database Locking Mode=1;Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Global Bulk Transactions=1;Jet OLEDB:New Database Password="""";Jet OLEDB:Create System Database=False;Jet OLEDB:Encrypt Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;Jet OLEDB:SFP=False";
			// 
			// oleDbInsertCommand1
			// 
			this.oleDbInsertCommand1.CommandText = "INSERT INTO Diary(ActionDate, ActionType, CaseID, Completed, Created, CreateUser," +
				" DateActioned, Description, LastUpdated, LastUser, Notes, UserID) VALUES (?, ?, " +
				"?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
			this.oleDbInsertCommand1.Connection = this.oleDbConnection1;
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ActionDate", System.Data.OleDb.OleDbType.DBDate, 0, "ActionDate"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ActionType", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ActionType", System.Data.DataRowVersion.Current, null));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("CaseID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "CaseID", System.Data.DataRowVersion.Current, null));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Completed", System.Data.OleDb.OleDbType.Boolean, 2, "Completed"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Created", System.Data.OleDb.OleDbType.DBDate, 0, "Created"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("CreateUser", System.Data.OleDb.OleDbType.VarWChar, 12, "CreateUser"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("DateActioned", System.Data.OleDb.OleDbType.DBDate, 0, "DateActioned"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Description", System.Data.OleDb.OleDbType.VarWChar, 255, "Description"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.DBDate, 0, "LastUpdated"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar, 12, "LastUser"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Notes", System.Data.OleDb.OleDbType.VarWChar, 0, "Notes"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("UserID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "UserID", System.Data.DataRowVersion.Current, null));
			// 
			// oleDbSelectCommand1
			// 
			this.oleDbSelectCommand1.CommandText = "SELECT ActionDate, ActionType, CaseID, Completed, Created, CreateUser, DateAction" +
				"ed, Description, ID, LastUpdated, LastUser, Notes, UserID FROM Diary";
			this.oleDbSelectCommand1.Connection = this.oleDbConnection1;
			// 
			// oleDbUpdateCommand1
			// 
			this.oleDbUpdateCommand1.CommandText = @"UPDATE Diary SET ActionDate = ?, ActionType = ?, CaseID = ?, Completed = ?, Created = ?, CreateUser = ?, DateActioned = ?, Description = ?, LastUpdated = ?, LastUser = ?, Notes = ?, UserID = ? WHERE (ID = ?) AND (ActionDate = ? OR ? IS NULL AND ActionDate IS NULL) AND (Completed = ?) AND (CreateUser = ? OR ? IS NULL AND CreateUser IS NULL) AND (Created = ? OR ? IS NULL AND Created IS NULL) AND (DateActioned = ? OR ? IS NULL AND DateActioned IS NULL) AND (Description = ? OR ? IS NULL AND Description IS NULL) AND (LastUpdated = ? OR ? IS NULL AND LastUpdated IS NULL) AND (LastUser = ? OR ? IS NULL AND LastUser IS NULL) AND (Notes = ? OR ? IS NULL AND Notes IS NULL)";
			this.oleDbUpdateCommand1.Connection = this.oleDbConnection1;
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ActionDate", System.Data.OleDb.OleDbType.Date, 0, "ActionDate"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ActionType", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ActionType", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("CaseID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "CaseID", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Completed", System.Data.OleDb.OleDbType.Boolean, 2, "Completed"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Created", System.Data.OleDb.OleDbType.Date, 0, "Created"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("CreateUser", System.Data.OleDb.OleDbType.VarWChar, 12, "CreateUser"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("DateActioned", System.Data.OleDb.OleDbType.Date, 0, "DateActioned"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Description", System.Data.OleDb.OleDbType.VarWChar, 255, "Description"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, "LastUpdated"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar, 12, "LastUser"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Notes", System.Data.OleDb.OleDbType.VarWChar, 0, "Notes"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("UserID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "UserID", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_ActionDate", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ActionDate", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_ActionDate1", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ActionDate", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_Completed", System.Data.OleDb.OleDbType.Boolean, 2, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Completed", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_CreateUser", System.Data.OleDb.OleDbType.VarWChar, 12, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CreateUser", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_CreateUser1", System.Data.OleDb.OleDbType.VarWChar, 12, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CreateUser", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_Created", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Created", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_Created1", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Created", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_DateActioned", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "DateActioned", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_DateActioned1", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "DateActioned", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_Description", System.Data.OleDb.OleDbType.VarWChar, 255, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Description", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_Description1", System.Data.OleDb.OleDbType.VarWChar, 255, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Description", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUpdated1", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUser", System.Data.OleDb.OleDbType.VarWChar, 12, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUser", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUser1", System.Data.OleDb.OleDbType.VarWChar, 12, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUser", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_Notes", System.Data.OleDb.OleDbType.VarWChar, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Notes", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_Notes1", System.Data.OleDb.OleDbType.VarWChar, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Notes", System.Data.DataRowVersion.Original, null));
			// 
			// textBoxEx1
			// 
			this.textBoxEx1.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dataSet11, "Diary.Notes"));
			this.textBoxEx1.Location = new System.Drawing.Point(187, 390);
			this.textBoxEx1.Name = "textBoxEx1";
			this.textBoxEx1.TabIndex = 28;
			this.textBoxEx1.Text = "textBoxEx1";
			// 
			// button10
			// 
			this.button10.Location = new System.Drawing.Point(616, 385);
			this.button10.Name = "button10";
			this.button10.Size = new System.Drawing.Size(47, 23);
			this.button10.TabIndex = 29;
			this.button10.Text = "bind";
			this.button10.Click += new System.EventHandler(this.button10_Click);
			// 
			// dtp1
			// 
			this.dtp1.Checked = false;
			this.dtp1.Format = System.Windows.Forms.DateTimePickerFormat.Short;
			this.dtp1.Location = new System.Drawing.Point(431, 384);
			this.dtp1.Name = "dtp1";
			this.dtp1.ShowCheckBox = true;
			this.dtp1.Size = new System.Drawing.Size(129, 20);
			this.dtp1.TabIndex = 30;
			// 
			// dtp2
			// 
			this.dtp2.Checked = false;
			this.dtp2.Format = System.Windows.Forms.DateTimePickerFormat.Short;
			this.dtp2.Location = new System.Drawing.Point(431, 416);
			this.dtp2.Name = "dtp2";
			this.dtp2.ShowCheckBox = true;
			this.dtp2.Size = new System.Drawing.Size(131, 20);
			this.dtp2.TabIndex = 31;
			// 
			// TestForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(711, 487);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.dtp2,
																		  this.dtp1,
																		  this.tabControl1,
																		  this.menuControl1,
																		  this.button10,
																		  this.textBoxEx1,
																		  this.tvwCases,
																		  this.outlookBar1,
																		  this.toolBarEx1,
																		  this.reBar1,
																		  this.cboBranch,
																		  this.button6,
																		  this.button5,
																		  this.button4,
																		  this.button3,
																		  this.button2,
																		  this.button1,
																		  this.lstTest,
																		  this.button8,
																		  this.button7,
																		  this.button9});
			this.Name = "TestForm";
			this.Text = "Test Form";
			this.tabControl1.ResumeLayout(false);
			this.tabPage1.ResumeLayout(false);
			this.tabPage3.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.dataSet11)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			try 
			{	
				CSession.GetConfig();
				cMyDB.Initialise();
				Application.Run(new MainForm());
			}
 			catch (Exception e)
			{
				MessageBox.Show("Cannot Continue : " + e.Message,"System Error");
			}
		}
		
		private void button5_Click(object sender, System.EventArgs e)
		{
            DataTable dat = cMyDB.GetDataTable("Select ID From LookupDefinitions");
			foreach(DataRow dr in dat.Rows)
				lstTest.Items.Add (dr["ID"]);
			dat = null;
		}

		private void lstTest_SelectedValueChanged(object sender, System.EventArgs e)
		{
			cboBranch.LookupID = lstTest.SelectedItem.ToString();
		}
		
		private void button1_Click(object sender, System.EventArgs e)
		{
			CSession.CaseSelected += new CaseEventHandler(Test_EventHandler);
		}

		private void Test_EventHandler(object sender, CaseEventArgs e)
		{
            MessageBox.Show("Case " + e.CaseID + " Selected");
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			Processing p = new Processing();
			p.progress.Minimum = 1;
			p.progress.Maximum = 5;
			p.Caption = "Doing some stuff";
			p.Show();
			p.Refresh();
			for (int i = p.progress.Minimum; i<(p.progress.Maximum + 1) ; i++)
			{
				p.progress.Value = i;}
			p.Close();
		}

		private void menuControl1_PopupStart(Crownwood.Magic.Menus.MenuCommand item)
		{
		
		}

		private void button6_Click(object sender, System.EventArgs e)
		{
			diaryListView1.GetData();
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			CSession.SelectCase(1);
		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			tvwCases.FillDefaultDebtTree();
		}

		private void diaryListView1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
		}

		private void button7_Click(object sender, System.EventArgs e)
		{
			this.dataSet11.Diary.Clear();
			this.oleDbDataAdapter1.Fill(this.dataSet11,"Diary");
			this.BindingContext[this.dataSet11, "Diary"].Position = 0;
			
		}

		private void button8_Click(object sender, System.EventArgs e)
		{
			this.BindingContext[this.dataSet11, "Diary"].EndCurrentEdit();
			int x = this.oleDbDataAdapter1.Update(this.dataSet11.Diary.GetChanges());
		}

		private void button9_Click(object sender, System.EventArgs e)
		{
			this.BindingContext[dataSet11, "Diary"].Position +=1;
		}

		private void button10_Click(object sender, System.EventArgs e)
		{
			this.dtp1.DataBindings.Add(new DTPBinding("Checked", this.dataSet11, "Diary.ActionDate"));
			this.dtp2.DataBindings.Add(new DTPBinding("Checked", this.dataSet11, "Diary.DateActioned"));
		}
	}
}
