using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for frmSecurityLevels.
	/// </summary>
	public class frmSecurityLevels : System.Windows.Forms.Form
	{
		private Crownwood.Magic.Controls.TabControl tabControl1;
		private Crownwood.Magic.Controls.TabPage tabPage1;
		private UtilityLibrary.WinControls.ButtonEx cmdCancel;
		private UtilityLibrary.WinControls.ButtonEx cmdOK;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label9;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboSettings;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboUsers;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboMailMerge;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboLetters;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboSaving;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboReporting;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboArchive;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboDelete;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboAdd;
		private System.Data.OleDb.OleDbDataAdapter daSecurityLevels;
		private System.Data.OleDb.OleDbCommand oleDbSelectCommand1;
		private System.Data.OleDb.OleDbCommand oleDbUpdateCommand1;
		private DebtManagerTest.dsSecurityLevels dsSecurityLevels1;
		private System.Windows.Forms.Label label10;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboMaintain;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmSecurityLevels()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			daSecurityLevels.SelectCommand.Connection = cMyDB.NewConnection();
			daSecurityLevels.UpdateCommand.Connection = daSecurityLevels.SelectCommand.Connection;

			this.tabPage1.BindingContext = this.BindingContext;
			daSecurityLevels.Fill(dsSecurityLevels1, "SecurityLevels");

			int lvl = CSession.User.UserLevel;
			dsSecurityLevels.SecurityLevelsRow slr = dsSecurityLevels1.SecurityLevels[0];
			if (lvl < slr.AddCases)
				this.cboAdd.Enabled = false;
			if (lvl < slr.ArchiveCases)
				this.cboArchive.Enabled = false;
			if (lvl < slr.BulkMailMerge)
				this.cboMailMerge.Enabled = false;
			if (lvl < slr.DeleteCases)
				this.cboDelete.Enabled = false;
			if (lvl < slr.OpenLetters)
				this.cboLetters.Enabled = false;
			if (lvl < slr.Reports)
				this.cboReporting.Enabled = false;
			if (lvl < slr.SaveLetters)
				this.cboSaving.Enabled = false;
			if (lvl < slr.Settings)
				this.cboSettings.Enabled = false;
			if (lvl < slr.UserEditor)
				this.cboUsers.Enabled = false;
			if (lvl < slr.MaintainCompanies)
				this.cboMaintain.Enabled = false;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.tabControl1 = new Crownwood.Magic.Controls.TabControl();
			this.tabPage1 = new Crownwood.Magic.Controls.TabPage();
			this.cboMaintain = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.dsSecurityLevels1 = new DebtManagerTest.dsSecurityLevels();
			this.label10 = new System.Windows.Forms.Label();
			this.cboAdd = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.cboDelete = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.cboArchive = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.cboReporting = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.cboSaving = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.cboLetters = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.cboMailMerge = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.cboUsers = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.cboSettings = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.label9 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.cmdCancel = new UtilityLibrary.WinControls.ButtonEx();
			this.cmdOK = new UtilityLibrary.WinControls.ButtonEx();
			this.daSecurityLevels = new System.Data.OleDb.OleDbDataAdapter();
			this.oleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbUpdateCommand1 = new System.Data.OleDb.OleDbCommand();
			this.tabControl1.SuspendLayout();
			this.tabPage1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dsSecurityLevels1)).BeginInit();
			this.SuspendLayout();
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					  this.tabPage1});
			this.tabControl1.Dock = System.Windows.Forms.DockStyle.Top;
			this.tabControl1.Font = new System.Drawing.Font("Tahoma", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.World, ((System.Byte)(0)));
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.PositionTop = true;
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.SelectedTab = this.tabPage1;
			this.tabControl1.Size = new System.Drawing.Size(292, 322);
			this.tabControl1.TabIndex = 0;
			this.tabControl1.TabPages.AddRange(new Crownwood.Magic.Controls.TabPage[] {
																						  this.tabPage1});
			// 
			// tabPage1
			// 
			this.tabPage1.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.cboMaintain,
																				   this.label10,
																				   this.cboAdd,
																				   this.cboDelete,
																				   this.cboArchive,
																				   this.cboReporting,
																				   this.cboSaving,
																				   this.cboLetters,
																				   this.cboMailMerge,
																				   this.cboUsers,
																				   this.cboSettings,
																				   this.label9,
																				   this.label8,
																				   this.label7,
																				   this.label6,
																				   this.label5,
																				   this.label4,
																				   this.label3,
																				   this.label2,
																				   this.label1});
			this.tabPage1.Location = new System.Drawing.Point(0, 25);
			this.tabPage1.Name = "tabPage1";
			this.tabPage1.Size = new System.Drawing.Size(292, 297);
			this.tabPage1.TabIndex = 3;
			this.tabPage1.Title = "General";
			// 
			// cboMaintain
			// 
			this.cboMaintain.AllowUpdates = false;
			this.cboMaintain.ComboValue = null;
			this.cboMaintain.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsSecurityLevels1, "SecurityLevels.MaintainCompanies"));
			this.cboMaintain.DataBound = true;
			this.cboMaintain.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboMaintain.ExtraRefreshes = true;
			this.cboMaintain.Location = new System.Drawing.Point(153, 257);
			this.cboMaintain.LookupID = "UserLevel";
			this.cboMaintain.Name = "cboMaintain";
			this.cboMaintain.Nullable = false;
			this.cboMaintain.TabIndex = 19;
			this.cboMaintain.Validating += new System.ComponentModel.CancelEventHandler(this.lookupCombo1_Validating);
			// 
			// dsSecurityLevels1
			// 
			this.dsSecurityLevels1.DataSetName = "dsSecurityLevels";
			this.dsSecurityLevels1.Locale = new System.Globalization.CultureInfo("en-GB");
			this.dsSecurityLevels1.Namespace = "http://www.tempuri.org/dsSecurityLevels.xsd";
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(12, 260);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(138, 16);
			this.label10.TabIndex = 18;
			this.label10.Text = "Maintain Company Details";
			// 
			// cboAdd
			// 
			this.cboAdd.AllowUpdates = false;
			this.cboAdd.ComboValue = null;
			this.cboAdd.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsSecurityLevels1, "SecurityLevels.AddCases"));
			this.cboAdd.DataBound = true;
			this.cboAdd.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboAdd.ExtraRefreshes = true;
			this.cboAdd.Location = new System.Drawing.Point(153, 230);
			this.cboAdd.LookupID = "UserLevel";
			this.cboAdd.Name = "cboAdd";
			this.cboAdd.Nullable = false;
			this.cboAdd.TabIndex = 17;
			this.cboAdd.Validating += new System.ComponentModel.CancelEventHandler(this.lookupCombo1_Validating);
			// 
			// cboDelete
			// 
			this.cboDelete.AllowUpdates = false;
			this.cboDelete.ComboValue = null;
			this.cboDelete.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsSecurityLevels1, "SecurityLevels.DeleteCases"));
			this.cboDelete.DataBound = true;
			this.cboDelete.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboDelete.ExtraRefreshes = true;
			this.cboDelete.Location = new System.Drawing.Point(153, 203);
			this.cboDelete.LookupID = "UserLevel";
			this.cboDelete.Name = "cboDelete";
			this.cboDelete.Nullable = false;
			this.cboDelete.TabIndex = 16;
			this.cboDelete.Validating += new System.ComponentModel.CancelEventHandler(this.lookupCombo1_Validating);
			// 
			// cboArchive
			// 
			this.cboArchive.AllowUpdates = false;
			this.cboArchive.ComboValue = null;
			this.cboArchive.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsSecurityLevels1, "SecurityLevels.ArchiveCases"));
			this.cboArchive.DataBound = true;
			this.cboArchive.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboArchive.ExtraRefreshes = true;
			this.cboArchive.Location = new System.Drawing.Point(153, 176);
			this.cboArchive.LookupID = "UserLevel";
			this.cboArchive.Name = "cboArchive";
			this.cboArchive.Nullable = false;
			this.cboArchive.TabIndex = 15;
			this.cboArchive.Validating += new System.ComponentModel.CancelEventHandler(this.lookupCombo1_Validating);
			// 
			// cboReporting
			// 
			this.cboReporting.AllowUpdates = false;
			this.cboReporting.ComboValue = null;
			this.cboReporting.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsSecurityLevels1, "SecurityLevels.Reports"));
			this.cboReporting.DataBound = true;
			this.cboReporting.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboReporting.ExtraRefreshes = true;
			this.cboReporting.Location = new System.Drawing.Point(153, 149);
			this.cboReporting.LookupID = "UserLevel";
			this.cboReporting.Name = "cboReporting";
			this.cboReporting.Nullable = false;
			this.cboReporting.TabIndex = 14;
			this.cboReporting.Validating += new System.ComponentModel.CancelEventHandler(this.lookupCombo1_Validating);
			// 
			// cboSaving
			// 
			this.cboSaving.AllowUpdates = false;
			this.cboSaving.ComboValue = null;
			this.cboSaving.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsSecurityLevels1, "SecurityLevels.SaveLetters"));
			this.cboSaving.DataBound = true;
			this.cboSaving.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboSaving.ExtraRefreshes = true;
			this.cboSaving.Location = new System.Drawing.Point(153, 122);
			this.cboSaving.LookupID = "UserLevel";
			this.cboSaving.Name = "cboSaving";
			this.cboSaving.Nullable = false;
			this.cboSaving.TabIndex = 13;
			this.cboSaving.Validating += new System.ComponentModel.CancelEventHandler(this.lookupCombo1_Validating);
			// 
			// cboLetters
			// 
			this.cboLetters.AllowUpdates = false;
			this.cboLetters.ComboValue = null;
			this.cboLetters.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsSecurityLevels1, "SecurityLevels.OpenLetters"));
			this.cboLetters.DataBound = true;
			this.cboLetters.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboLetters.ExtraRefreshes = true;
			this.cboLetters.Location = new System.Drawing.Point(153, 95);
			this.cboLetters.LookupID = "UserLevel";
			this.cboLetters.Name = "cboLetters";
			this.cboLetters.Nullable = false;
			this.cboLetters.TabIndex = 12;
			this.cboLetters.Validating += new System.ComponentModel.CancelEventHandler(this.lookupCombo1_Validating);
			// 
			// cboMailMerge
			// 
			this.cboMailMerge.AllowUpdates = false;
			this.cboMailMerge.ComboValue = null;
			this.cboMailMerge.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsSecurityLevels1, "SecurityLevels.BulkMailMerge"));
			this.cboMailMerge.DataBound = true;
			this.cboMailMerge.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboMailMerge.ExtraRefreshes = true;
			this.cboMailMerge.Location = new System.Drawing.Point(153, 68);
			this.cboMailMerge.LookupID = "UserLevel";
			this.cboMailMerge.Name = "cboMailMerge";
			this.cboMailMerge.Nullable = false;
			this.cboMailMerge.TabIndex = 11;
			this.cboMailMerge.Validating += new System.ComponentModel.CancelEventHandler(this.lookupCombo1_Validating);
			// 
			// cboUsers
			// 
			this.cboUsers.AllowUpdates = false;
			this.cboUsers.ComboValue = null;
			this.cboUsers.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsSecurityLevels1, "SecurityLevels.UserEditor"));
			this.cboUsers.DataBound = true;
			this.cboUsers.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboUsers.ExtraRefreshes = true;
			this.cboUsers.Location = new System.Drawing.Point(153, 41);
			this.cboUsers.LookupID = "UserLevel";
			this.cboUsers.Name = "cboUsers";
			this.cboUsers.Nullable = false;
			this.cboUsers.TabIndex = 10;
			this.cboUsers.Validating += new System.ComponentModel.CancelEventHandler(this.lookupCombo1_Validating);
			// 
			// cboSettings
			// 
			this.cboSettings.AllowUpdates = false;
			this.cboSettings.ComboValue = null;
			this.cboSettings.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsSecurityLevels1, "SecurityLevels.Settings"));
			this.cboSettings.DataBound = true;
			this.cboSettings.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboSettings.ExtraRefreshes = true;
			this.cboSettings.Location = new System.Drawing.Point(153, 14);
			this.cboSettings.LookupID = "UserLevel";
			this.cboSettings.Name = "cboSettings";
			this.cboSettings.Nullable = false;
			this.cboSettings.TabIndex = 9;
			this.cboSettings.Validating += new System.ComponentModel.CancelEventHandler(this.lookupCombo1_Validating);
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(12, 233);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(125, 14);
			this.label9.TabIndex = 8;
			this.label9.Text = "Add New Cases";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(12, 206);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(125, 14);
			this.label8.TabIndex = 7;
			this.label8.Text = "Delete Cases";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(12, 179);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(125, 14);
			this.label7.TabIndex = 6;
			this.label7.Text = "Archive Cases";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(12, 152);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(125, 14);
			this.label6.TabIndex = 5;
			this.label6.Text = "Use Reporting Options";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(12, 125);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(125, 14);
			this.label5.TabIndex = 4;
			this.label5.Text = "Use Letter Save Options";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(12, 98);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(125, 14);
			this.label4.TabIndex = 3;
			this.label4.Text = "Open/Edit Letters";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(12, 71);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(125, 14);
			this.label3.TabIndex = 2;
			this.label3.Text = "Use Bulk Mail Merge";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(12, 44);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(125, 14);
			this.label2.TabIndex = 1;
			this.label2.Text = "Do User Management";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(12, 17);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(125, 14);
			this.label1.TabIndex = 0;
			this.label1.Text = "View/Edit Configuration";
			// 
			// cmdCancel
			// 
			this.cmdCancel.CausesValidation = false;
			this.cmdCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdCancel.Location = new System.Drawing.Point(227, 334);
			this.cmdCancel.Name = "cmdCancel";
			this.cmdCancel.Size = new System.Drawing.Size(57, 23);
			this.cmdCancel.TabIndex = 6;
			this.cmdCancel.Text = "Cancel ";
			// 
			// cmdOK
			// 
			this.cmdOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.cmdOK.Location = new System.Drawing.Point(161, 334);
			this.cmdOK.Name = "cmdOK";
			this.cmdOK.Size = new System.Drawing.Size(57, 23);
			this.cmdOK.TabIndex = 5;
			this.cmdOK.Text = "OK ";
			this.cmdOK.Click += new System.EventHandler(this.cmdOK_Click);
			// 
			// daSecurityLevels
			// 
			this.daSecurityLevels.SelectCommand = this.oleDbSelectCommand1;
			this.daSecurityLevels.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																									   new System.Data.Common.DataTableMapping("Table", "SecurityLevels", new System.Data.Common.DataColumnMapping[] {
																																																						 new System.Data.Common.DataColumnMapping("AddCases", "AddCases"),
																																																						 new System.Data.Common.DataColumnMapping("ArchiveCases", "ArchiveCases"),
																																																						 new System.Data.Common.DataColumnMapping("BulkMailMerge", "BulkMailMerge"),
																																																						 new System.Data.Common.DataColumnMapping("Config_ID", "Config_ID"),
																																																						 new System.Data.Common.DataColumnMapping("DeleteCases", "DeleteCases"),
																																																						 new System.Data.Common.DataColumnMapping("OpenLetters", "OpenLetters"),
																																																						 new System.Data.Common.DataColumnMapping("Reports", "Reports"),
																																																						 new System.Data.Common.DataColumnMapping("SaveLetters", "SaveLetters"),
																																																						 new System.Data.Common.DataColumnMapping("Settings", "Settings"),
																																																						 new System.Data.Common.DataColumnMapping("UserEditor", "UserEditor")})});
			this.daSecurityLevels.UpdateCommand = this.oleDbUpdateCommand1;
			// 
			// oleDbSelectCommand1
			// 
			this.oleDbSelectCommand1.CommandText = "SELECT AddCases, ArchiveCases, BulkMailMerge, Config_ID, DeleteCases, OpenLetters" +
				", Reports, SaveLetters, Settings, UserEditor, MaintainCompanies FROM SecurityLev" +
				"els WHERE (Config_ID = 1)";
			// 
			// oleDbUpdateCommand1
			// 
			this.oleDbUpdateCommand1.CommandText = "UPDATE SecurityLevels SET AddCases = ?, ArchiveCases = ?, BulkMailMerge = ?, Conf" +
				"ig_ID = ?, DeleteCases = ?, OpenLetters = ?, Reports = ?, SaveLetters = ?, Setti" +
				"ngs = ?, UserEditor = ?, MaintainCompanies = ? WHERE (Config_ID = ?)";
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("AddCases", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "AddCases", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ArchiveCases", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ArchiveCases", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("BulkMailMerge", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "BulkMailMerge", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Config_ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "Config_ID", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("DeleteCases", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "DeleteCases", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("OpenLetters", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "OpenLetters", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Reports", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "Reports", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("SaveLetters", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "SaveLetters", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Settings", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "Settings", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("UserEditor", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "UserEditor", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("MaintainCompanies", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "MaintainCompanies", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_Config_ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "Config_ID", System.Data.DataRowVersion.Original, null));
			// 
			// frmSecurityLevels
			// 
			this.AcceptButton = this.cmdOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cmdCancel;
			this.ClientSize = new System.Drawing.Size(292, 363);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cmdCancel,
																		  this.cmdOK,
																		  this.tabControl1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "frmSecurityLevels";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Security Levels Required To...";
			this.tabControl1.ResumeLayout(false);
			this.tabPage1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.dsSecurityLevels1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void cmdOK_Click(object sender, System.EventArgs e)
		{
			this.BindingContext[dsSecurityLevels1, "SecurityLevels"].EndCurrentEdit();
			daSecurityLevels.Update(dsSecurityLevels1, "SecurityLevels");
			MessageBox.Show("Changes will not take effect until you restart the system.", "Configuration Changed");
		}

		private void lookupCombo1_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (sender is ComboBox)
			{
				if (Convert.ToInt32(((ComboBox)sender).SelectedValue) > CSession.User.UserLevel)
				{
					MessageBox.Show("You cannot set the required security level higher than your own.", "Invalid Selection");
					e.Cancel = true;
				}
				else if (((ComboBox)sender).SelectedIndex < 0)
					e.Cancel = true;
			}
		}
	}
}
